/*
 * Tirititran es un juego de naves en 2D ambientado en Cádiz
 * Copyright (C) 2004  Javier Pérez Pacheco
 *
 * Este juego tienen licencia Creative Commons y se permite
 * su modificacion y utilizacion libremente siempre y cuando se
 * cite al autor original y se comparta con la misma licencia.
 * No se permite su uso comercial.
 * 
 * Para mas informacion visite la web:
 * http://creativecommons.org/licenses/by-nc-sa/2.0/es/
 *
 * PROGRAMADOR
 * Javier Pérez Pacheco
 * Cadiz (Spain)
 * javi.pacheco@terra.es
 *
 * GRAFISMO Y 3D
 * Jesus Carrasco
 * Cadiz (Spain)
 * carrasco.carrasco@gmail.com
 *
 * MUSICA Y GRAFISMO
 * Shano Lores
 * Cadiz (Spain)
 * shano@mail.ono.es
 *
 */
 
 #include "configuracion.h"

 
/*****************************
**
** CLASE OPCIONES
**
******************************/

Configuracion::Configuracion() {
	puntuacionMenor = 99999999;
}

void Configuracion::configurar() {
	// archivo de configuracion
	FILE *f_opciones;
	char tmp[500], tmp_dir[63];
	if (getenv("HOME") != NULL) {
		//sprintf (directorio, "%s/.tirititran", getenv("HOME"));
		directorio = getenv("HOME");
		sprintf (tmp_dir, "mkdir %s/.tirititran", directorio);
		system(tmp_dir);
		sprintf (directorio, "%s/.tirititran", directorio);
	} else {
		directorio = "./data";
	}
	
	strcpy(tmp, "");
	sprintf (arch_opciones, "%s/opciones.dat", directorio);

	if ( (f_opciones=fopen(arch_opciones, "a+")) != NULL) {
		fread (tmp, 500, 1, f_opciones);
	} else {
		printf ("Archivo de opciones no cargado\n");
	}

	if ( strlen(tmp) == 0 ) {
		opcionesPorDefecto();
	} else {
		cargarOpciones();
	}
	fclose(f_opciones);
	strcpy(tmp, "");
	// archivo de puntuaciones
	FILE *f_puntuaciones;
	
	sprintf (arch_puntuacion, "%s/puntuaciones.dat", directorio);

	if ( (f_puntuaciones=fopen(arch_puntuacion, "a+")) != NULL) {
		fread (tmp, 500, 1, f_puntuaciones);
	} else {
		printf ("Archivo de puntuaciones no cargado\n");
	}

	if ( strlen(tmp) == 0 ) {
		puntuacionesPorDefecto();
	} else {
		cargarPuntuaciones();
	}
	fclose(f_puntuaciones);
	
	
}

void Configuracion::opcionesPorDefecto() {
	FILE *f_opciones;
	f_opciones=fopen(arch_opciones, "a+");
	
	char tmp_val[500];

	vol_musica = 2;
	sprintf (tmp_val, "vol_musica:%d\n", vol_musica);
	fwrite(tmp_val, strlen(tmp_val), 1, f_opciones);
	vol_sonido = 2;
	sprintf (tmp_val, "vol_sonido:%d\n", vol_sonido);
	fwrite(tmp_val, strlen(tmp_val), 1, f_opciones);
	aceleracionHardware = 1;
	sprintf (tmp_val, "ace_hardware:%d\n", aceleracionHardware);
	fwrite(tmp_val, strlen(tmp_val), 1, f_opciones);
	vel_juego = 1;
	sprintf (tmp_val, "vel_juego:%d\n", vel_juego);
	fwrite(tmp_val, strlen(tmp_val), 1, f_opciones);
	fullscreen = 0;
	sprintf (tmp_val, "fullscreen:%d\n", fullscreen);
	fwrite(tmp_val, strlen(tmp_val), 1, f_opciones);
	bpp = 1;
	sprintf (tmp_val, "bpp:%d\n", bpp);
	fwrite(tmp_val, strlen(tmp_val), 1, f_opciones);
	
	fclose(f_opciones);
}

void Configuracion::actualizarOpcion(char clave[63], int valor) {

	if (strcmp( clave, "vol_musica" )  == 0 ) {
		vol_musica = valor;
	} else if (strcmp( clave, "vol_sonido" ) == 0 ) {
		vol_sonido = valor;
	} else if (strcmp( clave, "ace_hardware" ) == 0 ) {
		aceleracionHardware = valor;
	} else if (strcmp( clave, "vel_juego" ) == 0 ) {
		vel_juego = valor;
	} else if (strcmp( clave, "fullscreen" ) == 0 ) {
		fullscreen = valor;
	} else if (strcmp( clave, "bpp" ) == 0 ) {
		bpp = valor;
	}
	
}

void Configuracion::actualizarPuntuacion(char clave[63], int valor, int cont) {

	punt_puntos[cont] = valor;
	strcpy(punt_nombres[cont], clave);
	
	// guardamos las puntuacion mas baja
	
	if (valor<puntuacionMenor) {
		puntuacionMenor = valor;
	}

}

void Configuracion::puntuacionesPorDefecto() {

	FILE *f_puntuaciones;
	f_puntuaciones=fopen(arch_puntuacion, "a+");
	
	char tmp_val[500];
	//printf("el archivo esta vacio\n"); 
	sprintf (tmp_val, "Troy:5000\n");
	strcpy(punt_nombres[0], "Troy");
	punt_puntos[0] = 5000;
	fwrite(tmp_val, strlen(tmp_val), 1, f_puntuaciones);
	
	sprintf (tmp_val, "La uchi:4500\n");
	strcpy(punt_nombres[1], "La uchi");
	punt_puntos[1] = 45000;
	fwrite(tmp_val, strlen(tmp_val), 1, f_puntuaciones);
	
	sprintf (tmp_val, "Fletilla:3500\n");
	strcpy(punt_nombres[2], "Fletilla");
	punt_puntos[2] = 3500;
	fwrite(tmp_val, strlen(tmp_val), 1, f_puntuaciones);
	
	sprintf (tmp_val, "Magico:3000\n");
	strcpy(punt_nombres[3], "Magico");
	punt_puntos[3] = 3000;
	fwrite(tmp_val, strlen(tmp_val), 1, f_puntuaciones);
	
	sprintf (tmp_val, "Robbison:2500\n");
	strcpy(punt_nombres[4], "Robbison");
	punt_puntos[4] = 2500;
	fwrite(tmp_val, strlen(tmp_val), 1, f_puntuaciones);
	
	fclose(f_puntuaciones);
	
	puntuacionMenor = 2500;
	
}

void Configuracion::cargarOpciones() {
    char palabra[81];
    char *c, *clave, *valor;
	int valorint;
	FILE *f_opciones;
	f_opciones=fopen(arch_opciones, "a+");

	do
    {
        c = fgets(palabra, 81, f_opciones); 
        if (c != NULL) {
			clave = strtok( palabra, ":" );
			valor = strtok( NULL, "\n" );
			valorint = atoi (valor);
			actualizarOpcion(clave, valorint);
		}
    }   while (c != NULL); 
	
	fclose(f_opciones);
}

void Configuracion::cargarPuntuaciones() {
    char palabra[81];
    char *c, *clave, *valor;
	int valorint, cont;
	FILE *f_puntuaciones;
	f_puntuaciones=fopen(arch_puntuacion, "a+");
	cont = 0;
	do
    {
        c = fgets(palabra, 81, f_puntuaciones); 
        if (c != NULL) {
			clave = strtok( palabra, ":" );
			valor = strtok( NULL, "\n" );
			valorint = atoi (valor);	
			actualizarPuntuacion(clave, valorint, cont);
		}
		cont++;
    }   while (c != NULL); 
	
	fclose(f_puntuaciones);
}


void Configuracion::guardarOpciones() {
	FILE *f_opciones;
	f_opciones=fopen(arch_opciones, "w+");
	
	char tmp_val[500];
	sprintf (tmp_val, "vol_musica:%d\n", vol_musica);
	fwrite(tmp_val, strlen(tmp_val), 1, f_opciones);
	
	sprintf (tmp_val, "vol_sonido:%d\n", vol_sonido);
	fwrite(tmp_val, strlen(tmp_val), 1, f_opciones);
	
	sprintf (tmp_val, "ace_hardware:%d\n", aceleracionHardware);
	fwrite(tmp_val, strlen(tmp_val), 1, f_opciones);
	
	sprintf (tmp_val, "vel_juego:%d\n", vel_juego);
	fwrite(tmp_val, strlen(tmp_val), 1, f_opciones);
	
	sprintf (tmp_val, "fullscreen:%d\n", fullscreen);
	fwrite(tmp_val, strlen(tmp_val), 1, f_opciones);
	
	sprintf (tmp_val, "bpp:%d\n", bpp);
	fwrite(tmp_val, strlen(tmp_val), 1, f_opciones);
	
	fclose(f_opciones);

}

void Configuracion::guardarPuntuacion(char nombre[15], int puntos) {
	//printf ("%s : %d\n", nombre, puntos);
	int i;

	for (i=0; i<5; i++) {
		if (punt_puntos[i] == puntuacionMenor) {
			strcpy(punt_nombres[i], nombre);
			punt_puntos[i] = puntos;
			break;
		}
	}

	puntuacionMenor = 99999999;
	
	FILE *f_puntuaciones;
	f_puntuaciones=fopen(arch_puntuacion, "w+");
	
	char tmp_val[100];
	
	for (i=0; i<5; i++) {
		sprintf (tmp_val, "%s:%d\n", punt_nombres[i], punt_puntos[i]);
		fwrite(tmp_val, strlen(tmp_val), 1, f_puntuaciones);
		if (puntuacionMenor>punt_puntos[i]) {
			puntuacionMenor = punt_puntos[i];
		}
	}
	
	fclose(f_puntuaciones);

	
}


int Configuracion::getOpcion(char clave[63]) {

	if (strcmp( clave, "vol_musica" )  == 0 ) {
		return vol_musica;
	} else if (strcmp( clave, "vol_sonido" ) == 0 ) {
		return vol_sonido;
	} else if (strcmp( clave, "ace_hardware" ) == 0 ) {
		return aceleracionHardware;
	} else if (strcmp( clave, "vel_juego" ) == 0 ) {
		return vel_juego;
	} else if (strcmp( clave, "fullscreen" ) == 0 ) {
		return fullscreen;
	} else if (strcmp( clave, "bpp" ) == 0 ) {
		return bpp;
	}
	return -1;
}

void Configuracion::ordenarPuntuaciones() {
	int N = 5;
	int i,j,menor,aux;
	char auxNombre[30];
	
	for(i=0;i<N-1;i++)
	{
	   for(j=i+1,menor=i;j<N;j++)
	   if(punt_puntos[j]>punt_puntos[menor]) 
		  menor=j; 
	   aux=punt_puntos[i]; 
	   punt_puntos[i]=punt_puntos[menor]; 
	   punt_puntos[menor]=aux;
	   strcpy(auxNombre, punt_nombres[i]);
	   strcpy(punt_nombres[i], punt_nombres[menor]);
	   strcpy(punt_nombres[menor], auxNombre);
	 }
 }
