/*
 * Tirititran es un juego de naves en 2D ambientado en Cádiz
 * Copyright (C) 2004  Javier Pérez Pacheco
 *
 * Este juego tienen licencia Creative Commons y se permite
 * su modificacion y utilizacion libremente siempre y cuando se
 * cite al autor original y se comparta con la misma licencia.
 * No se permite su uso comercial.
 * 
 * Para mas informacion visite la web:
 * http://creativecommons.org/licenses/by-nc-sa/2.0/es/
 *
 * PROGRAMADOR
 * Javier Pérez Pacheco
 * Cadiz (Spain)
 * javi.pacheco@terra.es
 *
 * GRAFISMO Y 3D
 * Jesus Carrasco
 * Cadiz (Spain)
 * carrasco.carrasco@gmail.com
 *
 * MUSICA Y GRAFISMO
 * Shano Lores
 * Cadiz (Spain)
 * shano@mail.ono.es
 *
 */
 
 #include "explosion.h"
 
/*****************************
**
** CLASE EXPLOSION
**
******************************/

 Explosion::Explosion(SDL_Surface *screen) {
 	Frame frExpGav0, frExpGav1, frExpGav2, frExpGav3, frExpGav4, frExpGav5;
	Frame frExpGav20, frExpGav21, frExpGav22, frExpGav23, frExpGav24, frExpGav25;
	Frame frExpNaveP0, frExpNaveP1, frExpNaveP2, frExpNaveP3, frExpNaveP4, frExpNaveP5, frExpNaveP6, frExpNaveP7;
	Frame frExpNaveM0, frExpNaveM1, frExpNaveM2, frExpNaveM3, frExpNaveM4, frExpNaveM5, frExpNaveM6, frExpNaveM7;
	Frame frExpNaveG0, frExpNaveG1, frExpNaveG2, frExpNaveG3, frExpNaveG4, frExpNaveG5, frExpNaveG6, frExpNaveG7;
	Frame frExpDispG0, frExpDispG1, frExpDispG2, frExpDispG3;
	Frame frExpCangrebot0, frExpCangrebot1, frExpCangrebot2, frExpCangrebot3, frExpCangrebot4;
	Frame frExpCangrebot5, frExpCangrebot6, frExpCangrebot7, frExpCangrebot8;
	Frame frExpLancha0, frExpLancha1, frExpLancha2, frExpLancha3, frExpLancha4;
	Frame frExpLancha5, frExpLancha6, frExpLancha7, frExpLancha8, frExpLancha9;
	Frame frExpCaseta0, frExpCaseta1, frExpCaseta2, frExpCaseta3, frExpCaseta4;
	Frame frExpCaseta5, frExpCaseta6, frExpCaseta7;
	Frame frExpPompaGr0, frExpPompaGr1, frExpPompaGr2;
	Frame frExpPompaPeq0, frExpPompaPeq1, frExpPompaPeq2;
	Frame frExpCocheS0, frExpCocheS1, frExpCocheS2, frExpCocheS3, frExpCocheS4;
	Frame frExpCocheS5, frExpCocheS6, frExpCocheS7, frExpCocheS8;
	Frame frExpMed0, frExpMed1, frExpMed2, frExpMed3, frExpMed4;
	Frame frExpMed5, frExpMed6, frExpMed7, frExpMed8, frExpMed9;
	Frame frExpMed10, frExpMed11, frExpMed12, frExpMed13, frExpMed14;
	Frame frExpMed15, frExpMed16, frExpMed17, frExpMed18, frExpMed19;
	Frame frExpMed20, frExpMed21, frExpMed22, frExpMed23, frExpMed24, frExpMed25, frExpMed26;
	Frame frExpGr0, frExpGr1, frExpGr2, frExpGr3, frExpGr4;
	Frame frExpGr5, frExpGr6, frExpGr7, frExpGr8, frExpGr9;
	Frame frExpGr10, frExpGr11, frExpGr12, frExpGr13, frExpGr14;
	Frame frExpGr15, frExpGr16, frExpGr17, frExpGr18, frExpGr19;
	Frame frExpGr20, frExpGr21, frExpGr22, frExpGr23, frExpGr24;
	Frame frExpGr25, frExpGr26, frExpGr27, frExpGr28, frExpGr29;
	Frame frExpGr30, frExpGr31, frExpGr32, frExpGr33, frExpGr34;
	Frame frExpGr35, frExpGr36;
	Frame frBarrera0, frBarrera1, frBarrera2, frBarrera3;
	
	Frame frCangrejo, frPurpo;
	
	int i;
	char tmpch[127];
	// sprites de la explosión de gaviotas 1

	sprintf (tmpch, "%s/explosiones.tim", DATA_DIR);
	
	frCangrejo.loadFromRAR (tmpch, "cangrejo.timp");
	cangrejo = new Elemento();
	cangrejo->addFrame(frCangrejo);
	cangrejo->selFrame(0);
	
	frPurpo.loadFromRAR (tmpch, "purpo.timp");
	purpo = new Elemento();
	purpo->addFrame(frPurpo);
	purpo->selFrame(0);
	
	frExpGav0.loadFromRAR (tmpch, "exp_gaviota1_0.timp");
	frExpGav1.loadFromRAR(tmpch, "exp_gaviota1_1.timp");	 
	frExpGav2.loadFromRAR(tmpch, "exp_gaviota1_2.timp");	
	frExpGav3.loadFromRAR(tmpch, "exp_gaviota1_3.timp");
	frExpGav4.loadFromRAR(tmpch, "exp_gaviota1_4.timp");
	frExpGav5.loadFromRAR(tmpch, "exp_gaviota1_5.timp");	
	
	for (i=0; i < MAXENE_GEN1; i++) {
		explosion_gav1[i] = new Elemento(6);
		explosion_gav1[i]->addFrame(frExpGav0);
		explosion_gav1[i]->addFrame(frExpGav1);
		explosion_gav1[i]->addFrame(frExpGav2);
		explosion_gav1[i]->addFrame(frExpGav3);
		explosion_gav1[i]->addFrame(frExpGav4);
		explosion_gav1[i]->addFrame(frExpGav5);
		
		explosion_gav1[i]->setAlign(ALIGN_CENTER);
		explosion_gav1[i]->setVAlign(VALIGN_CENTER);
		explosion_gav1[i]->selFrame(0);
		explosion_gav1[i]->setActivo(0);
	}
	
	// sprites de la explosión de gaviotas 2
	frExpGav20.loadFromRAR(tmpch, "exp_gaviota2_0.timp");		
	frExpGav21.loadFromRAR(tmpch, "exp_gaviota2_1.timp");
	frExpGav22.loadFromRAR(tmpch, "exp_gaviota2_2.timp");
	frExpGav23.loadFromRAR(tmpch, "exp_gaviota2_3.timp");
	frExpGav24.loadFromRAR(tmpch, "exp_gaviota2_4.timp");
	frExpGav25.loadFromRAR(tmpch, "exp_gaviota2_5.timp");
	
	for (i=0; i < MAXENE_GEN1; i++) {
		explosion_gav2[i] = new Elemento(6);
		explosion_gav2[i]->addFrame(frExpGav20);
		explosion_gav2[i]->addFrame(frExpGav21);
		explosion_gav2[i]->addFrame(frExpGav22);
		explosion_gav2[i]->addFrame(frExpGav23);
		explosion_gav2[i]->addFrame(frExpGav24);
		explosion_gav2[i]->addFrame(frExpGav25);
		
		explosion_gav2[i]->setAlign(ALIGN_CENTER);
		explosion_gav2[i]->setVAlign(VALIGN_CENTER);		
		explosion_gav2[i]->selFrame(0);
		explosion_gav2[i]->setActivo(0);
	}
	
	// sprites de la explosión de nave pequeña	
	frExpNaveP0.loadFromRAR(tmpch, "exp_navepeq0.timp");
	frExpNaveP1.loadFromRAR(tmpch, "exp_navepeq1.timp");
	frExpNaveP2.loadFromRAR(tmpch, "exp_navepeq2.timp");
	frExpNaveP3.loadFromRAR(tmpch, "exp_navepeq3.timp");
	frExpNaveP4.loadFromRAR(tmpch, "exp_navepeq4.timp");
	frExpNaveP5.loadFromRAR(tmpch, "exp_navepeq5.timp");
	frExpNaveP6.loadFromRAR(tmpch, "exp_navepeq6.timp");
	frExpNaveP7.loadFromRAR(tmpch, "exp_navepeq7.timp");
	
	for (i=0; i < MAXENE_GEN1; i++) {
		explosion_navepeq[i] = new Elemento(8);
		explosion_navepeq[i]->addFrame(frExpNaveP0);
		explosion_navepeq[i]->addFrame(frExpNaveP1);
		explosion_navepeq[i]->addFrame(frExpNaveP2);
		explosion_navepeq[i]->addFrame(frExpNaveP3);
		explosion_navepeq[i]->addFrame(frExpNaveP4);
		explosion_navepeq[i]->addFrame(frExpNaveP5);
		explosion_navepeq[i]->addFrame(frExpNaveP6);
		explosion_navepeq[i]->addFrame(frExpNaveP7);
		
		explosion_navepeq[i]->setAlign(ALIGN_CENTER);
		explosion_navepeq[i]->setVAlign(VALIGN_CENTER);
		explosion_navepeq[i]->selFrame(0);
		explosion_navepeq[i]->setActivo(0);
	}
	
	// sprites de la explosión de nave mediana	
	frExpNaveM0.loadFromRAR(tmpch, "exp_navemed0.timp");
	frExpNaveM1.loadFromRAR(tmpch, "exp_navemed1.timp");		
	frExpNaveM2.loadFromRAR(tmpch, "exp_navemed2.timp");		
	frExpNaveM3.loadFromRAR(tmpch, "exp_navemed3.timp");		
	frExpNaveM4.loadFromRAR(tmpch, "exp_navemed4.timp");
	frExpNaveM5.loadFromRAR(tmpch, "exp_navemed5.timp");
	frExpNaveM6.loadFromRAR(tmpch, "exp_navemed6.timp");		
	frExpNaveM7.loadFromRAR(tmpch, "exp_navemed7.timp");		

	
	for (i=0; i < MAXENE_GEN2*2; i++) {
		explosion_navemed[i] = new Elemento(8);
		explosion_navemed[i]->addFrame(frExpNaveM0);
		explosion_navemed[i]->addFrame(frExpNaveM1);
		explosion_navemed[i]->addFrame(frExpNaveM2);
		explosion_navemed[i]->addFrame(frExpNaveM3);
		explosion_navemed[i]->addFrame(frExpNaveM4);
		explosion_navemed[i]->addFrame(frExpNaveM5);
		explosion_navemed[i]->addFrame(frExpNaveM6);
		explosion_navemed[i]->addFrame(frExpNaveM7);
		
		explosion_navemed[i]->setAlign(ALIGN_CENTER);
		explosion_navemed[i]->setVAlign(VALIGN_CENTER);
		explosion_navemed[i]->selFrame(0);
		explosion_navemed[i]->setActivo(0);
	}

	// sprites de la explosión de nave grande
	frExpNaveG0.loadFromRAR(tmpch, "expgrande_0.timp");
	frExpNaveG1.loadFromRAR(tmpch, "expgrande_1.timp");		
	frExpNaveG2.loadFromRAR(tmpch, "expgrande_2.timp");		
	frExpNaveG3.loadFromRAR(tmpch, "expgrande_3.timp");
	frExpNaveG4.loadFromRAR(tmpch, "expgrande_4.timp");	
	frExpNaveG5.loadFromRAR(tmpch, "expgrande_5.timp");
	frExpNaveG6.loadFromRAR(tmpch, "expgrande_6.timp");
	frExpNaveG7.loadFromRAR(tmpch, "expgrande_7.timp");
	
	for (i=0; i < MAXENE_GEN3*2; i++) {
		explosion_navegr[i] = new Elemento(8);
		explosion_navegr[i]->addFrame(frExpNaveG0);
		explosion_navegr[i]->addFrame(frExpNaveG1);
		explosion_navegr[i]->addFrame(frExpNaveG2);
		explosion_navegr[i]->addFrame(frExpNaveG3);
		explosion_navegr[i]->addFrame(frExpNaveG4);
		explosion_navegr[i]->addFrame(frExpNaveG5);
		explosion_navegr[i]->addFrame(frExpNaveG6);
		explosion_navegr[i]->addFrame(frExpNaveG7);
		
		explosion_navegr[i]->setAlign(ALIGN_CENTER);
		explosion_navegr[i]->setVAlign(VALIGN_CENTER);
		explosion_navegr[i]->selFrame(0);
		explosion_navegr[i]->setActivo(0);
	}
	
	// sprites de la explosión del yate	
	Frame frExpYate0, frExpYate1, frExpYate2, frExpYate3, frExpYate4, frExpYate5;
	Frame frExpYate6, frExpYate7, frExpYate8, frExpYate9;
	
	frExpYate0.loadFromRAR(tmpch, "exp_barkito0.timp");
	frExpYate1.loadFromRAR(tmpch, "exp_barkito1.timp");
	frExpYate2.loadFromRAR(tmpch, "exp_barkito2.timp");
	frExpYate3.loadFromRAR(tmpch, "exp_barkito3.timp");
	frExpYate4.loadFromRAR(tmpch, "exp_barkito4.timp");
	frExpYate5.loadFromRAR(tmpch, "exp_barkito5.timp");
	frExpYate6.loadFromRAR(tmpch, "exp_barkito6.timp");
	frExpYate7.loadFromRAR(tmpch, "exp_barkito7.timp");
	frExpYate8.loadFromRAR(tmpch, "exp_barkito8.timp");
	frExpYate9.loadFromRAR(tmpch, "exp_barkito9.timp");
	
	for (i=0; i < MAXENE_YATE; i++) {
		explosion_yate[i] = new Elemento(10);
		explosion_yate[i]->addFrame(frExpYate0);
		explosion_yate[i]->addFrame(frExpYate1);
		explosion_yate[i]->addFrame(frExpYate2);
		explosion_yate[i]->addFrame(frExpYate3);
		explosion_yate[i]->addFrame(frExpYate4);
		explosion_yate[i]->addFrame(frExpYate5);
		explosion_yate[i]->addFrame(frExpYate6);
		explosion_yate[i]->addFrame(frExpYate7);
		explosion_yate[i]->addFrame(frExpYate8);
		explosion_yate[i]->addFrame(frExpYate9);
		
		explosion_yate[i]->setAlign(ALIGN_CENTER);
		explosion_yate[i]->setVAlign(VALIGN_CENTER);
		explosion_yate[i]->selFrame(0);
		explosion_yate[i]->setActivo(0);
	}
	
	// sprites de la explosión de las balas grandes de enemigos
	frExpDispG0.loadFromRAR(tmpch, "exp_balaenemigo2_0.timp");
	frExpDispG1.loadFromRAR(tmpch, "exp_balaenemigo2_1.timp");		
	frExpDispG2.loadFromRAR(tmpch, "exp_balaenemigo2_2.timp");
	frExpDispG3.loadFromRAR(tmpch, "exp_balaenemigo2_3.timp");
	
	for (i=0; i < MAXDISP_GR; i++) {
		explosion_dispgr[i] = new Elemento(4);
		explosion_dispgr[i]->addFrame(frExpDispG0);
		explosion_dispgr[i]->addFrame(frExpDispG1);
		explosion_dispgr[i]->addFrame(frExpDispG2);
		explosion_dispgr[i]->addFrame(frExpDispG3);
		
		explosion_dispgr[i]->setAlign(ALIGN_CENTER);
		explosion_dispgr[i]->setVAlign(VALIGN_CENTER);
		explosion_dispgr[i]->selFrame(0);
		explosion_dispgr[i]->setActivo(0);
	}
	
	// sprites de la explosión de las balas grandes azules de enemigos
	frExpDispG0.loadFromRAR(tmpch, "exp_balaenemigo3_0.timp");
	frExpDispG1.loadFromRAR(tmpch, "exp_balaenemigo3_1.timp");		
	frExpDispG2.loadFromRAR(tmpch, "exp_balaenemigo3_2.timp");
	frExpDispG3.loadFromRAR(tmpch, "exp_balaenemigo3_3.timp");
	
	for (i=0; i < MAXDISP_GR; i++) {
		explosion_dispgr_azul[i] = new Elemento(4);
		explosion_dispgr_azul[i]->addFrame(frExpDispG0);
		explosion_dispgr_azul[i]->addFrame(frExpDispG1);
		explosion_dispgr_azul[i]->addFrame(frExpDispG2);
		explosion_dispgr_azul[i]->addFrame(frExpDispG3);
		
		explosion_dispgr_azul[i]->setAlign(ALIGN_CENTER);
		explosion_dispgr_azul[i]->setVAlign(VALIGN_CENTER);
		explosion_dispgr_azul[i]->selFrame(0);
		explosion_dispgr_azul[i]->setActivo(0);
	}
	
	// sprites de la explosión de los congrebots
	frExpCangrebot0.loadFromRAR(tmpch, "exp_cangrebot0.timp");
	frExpCangrebot1.loadFromRAR(tmpch, "exp_cangrebot1.timp");	
	frExpCangrebot2.loadFromRAR(tmpch, "exp_cangrebot2.timp");
	frExpCangrebot3.loadFromRAR(tmpch, "exp_cangrebot3.timp");
	frExpCangrebot4.loadFromRAR(tmpch, "exp_cangrebot4.timp");
	frExpCangrebot5.loadFromRAR(tmpch, "exp_cangrebot5.timp");
	frExpCangrebot6.loadFromRAR(tmpch, "exp_cangrebot6.timp");		
	frExpCangrebot7.loadFromRAR(tmpch, "exp_cangrebot7.timp");
	frExpCangrebot8.loadFromRAR(tmpch, "exp_cangrebot8.timp");
	
	for (i=0; i < MAXENE_MARINOS; i++) {
		explosion_cangrebot[i] = new Elemento(9);
		explosion_cangrebot[i]->addFrame(frExpCangrebot0);
		explosion_cangrebot[i]->addFrame(frExpCangrebot1);
		explosion_cangrebot[i]->addFrame(frExpCangrebot2);
		explosion_cangrebot[i]->addFrame(frExpCangrebot3);
		explosion_cangrebot[i]->addFrame(frExpCangrebot4);
		explosion_cangrebot[i]->addFrame(frExpCangrebot5);
		explosion_cangrebot[i]->addFrame(frExpCangrebot6);
		explosion_cangrebot[i]->addFrame(frExpCangrebot7);
		explosion_cangrebot[i]->addFrame(frExpCangrebot8);
		
		explosion_cangrebot[i]->setAlign(ALIGN_CENTER);
		explosion_cangrebot[i]->setVAlign(VALIGN_CENTER);
		explosion_cangrebot[i]->selFrame(0);
		explosion_cangrebot[i]->setActivo(0);
	}
	
// sprites de la explosión de los congrebots
	frExpCangrebot0.loadFromRAR(tmpch, "exp_purpito0.timp");
	frExpCangrebot1.loadFromRAR(tmpch, "exp_purpito1.timp");	
	frExpCangrebot2.loadFromRAR(tmpch, "exp_purpito2.timp");
	frExpCangrebot3.loadFromRAR(tmpch, "exp_purpito3.timp");
	frExpCangrebot4.loadFromRAR(tmpch, "exp_purpito4.timp");
	frExpCangrebot5.loadFromRAR(tmpch, "exp_purpito5.timp");
	frExpCangrebot6.loadFromRAR(tmpch, "exp_purpito6.timp");		
	frExpCangrebot7.loadFromRAR(tmpch, "exp_purpito7.timp");
	
	for (i=0; i < MAXENE_MARINOS; i++) {
		explosion_pulpo[i] = new Elemento(8);
		explosion_pulpo[i]->addFrame(frExpCangrebot0);
		explosion_pulpo[i]->addFrame(frExpCangrebot1);
		explosion_pulpo[i]->addFrame(frExpCangrebot2);
		explosion_pulpo[i]->addFrame(frExpCangrebot3);
		explosion_pulpo[i]->addFrame(frExpCangrebot4);
		explosion_pulpo[i]->addFrame(frExpCangrebot5);
		explosion_pulpo[i]->addFrame(frExpCangrebot6);
		explosion_pulpo[i]->addFrame(frExpCangrebot7);
		
		explosion_pulpo[i]->setAlign(ALIGN_CENTER);
		explosion_pulpo[i]->setVAlign(VALIGN_CENTER);
		explosion_pulpo[i]->selFrame(0);
		explosion_pulpo[i]->setActivo(0);
	}
	
	// sprites de la explosión de las lanchas
	frExpLancha0.loadFromRAR(tmpch, "lancha_exp0.timp");	
	frExpLancha1.loadFromRAR(tmpch, "lancha_exp1.timp");		
	frExpLancha2.loadFromRAR(tmpch, "lancha_exp2.timp");		
	frExpLancha3.loadFromRAR(tmpch, "lancha_exp3.timp");	
	frExpLancha4.loadFromRAR(tmpch, "lancha_exp4.timp");
	frExpLancha5.loadFromRAR(tmpch, "lancha_exp5.timp");		
	frExpLancha6.loadFromRAR(tmpch, "lancha_exp6.timp");	
	frExpLancha7.loadFromRAR(tmpch, "lancha_exp7.timp");
	frExpLancha8.loadFromRAR(tmpch, "lancha_exp8.timp");
	frExpLancha9.loadFromRAR(tmpch, "lancha_exp9.timp");
	
	for (i=0; i < MAXENE_AUTOMARINO; i++) {
		explosion_lancha[i] = new Elemento(9);
		explosion_lancha[i]->addFrame(frExpLancha0);
		explosion_lancha[i]->addFrame(frExpLancha1);
		explosion_lancha[i]->addFrame(frExpLancha2);
		explosion_lancha[i]->addFrame(frExpLancha3);
		explosion_lancha[i]->addFrame(frExpLancha4);
		explosion_lancha[i]->addFrame(frExpLancha5);
		explosion_lancha[i]->addFrame(frExpLancha6);
		explosion_lancha[i]->addFrame(frExpLancha7);
		explosion_lancha[i]->addFrame(frExpLancha8);
		explosion_lancha[i]->addFrame(frExpLancha9);
		
		explosion_lancha[i]->setAlign(ALIGN_CENTER);
		explosion_lancha[i]->setVAlign(VALIGN_CENTER);
		explosion_lancha[i]->selFrame(0);
		explosion_lancha[i]->setActivo(0);
	}
	
	// sprites de la explosión de las casetas
	frExpCaseta0.loadFromRAR(tmpch, "caseta_exp0.timp");	
	frExpCaseta1.loadFromRAR(tmpch, "caseta_exp1.timp");		
	frExpCaseta2.loadFromRAR(tmpch, "caseta_exp2.timp");	
	frExpCaseta3.loadFromRAR(tmpch, "caseta_exp3.timp");	
	frExpCaseta4.loadFromRAR(tmpch, "caseta_exp4.timp");		
	frExpCaseta5.loadFromRAR(tmpch, "caseta_exp5.timp");
	frExpCaseta6.loadFromRAR(tmpch, "caseta_exp6.timp");	
	frExpCaseta7.loadFromRAR(tmpch, "caseta_exp7.timp");
	
	for (i=0; i < MAXENE_CONSTRUCCIONES; i++) {
		explosion_caseta[i] = new Elemento(8);
		explosion_caseta[i]->addFrame(frExpCaseta0);
		explosion_caseta[i]->addFrame(frExpCaseta1);
		explosion_caseta[i]->addFrame(frExpCaseta2);
		explosion_caseta[i]->addFrame(frExpCaseta3);
		explosion_caseta[i]->addFrame(frExpCaseta4);
		explosion_caseta[i]->addFrame(frExpCaseta5);
		explosion_caseta[i]->addFrame(frExpCaseta6);
		explosion_caseta[i]->addFrame(frExpCaseta7);
		
		explosion_caseta[i]->setAlign(ALIGN_CENTER);
		explosion_caseta[i]->setVAlign(VALIGN_CENTER);
		explosion_caseta[i]->selFrame(0);
		explosion_caseta[i]->setActivo(0);
	}
	
	// sprites de la explosión de las pompas grandes
	frExpPompaGr0.loadFromRAR(tmpch, "exp_pompa_gr0.timp");	
	frExpPompaGr1.loadFromRAR(tmpch, "exp_pompa_gr1.timp");		
	frExpPompaGr2.loadFromRAR(tmpch, "exp_pompa_gr2.timp");		
	
	frExpPompaPeq0.loadFromRAR(tmpch, "exp_pompa_peq0.timp");		
	frExpPompaPeq1.loadFromRAR(tmpch, "exp_pompa_peq1.timp");		
	frExpPompaPeq2.loadFromRAR(tmpch, "exp_pompa_peq2.timp");		
	
	for (i=0; i < MAXDISP_POMPA; i++) {
		explosion_pompagr[i] = new Elemento(3);
		explosion_pompagr[i]->addFrame(frExpPompaGr0);
		explosion_pompagr[i]->addFrame(frExpPompaGr1);
		explosion_pompagr[i]->addFrame(frExpPompaGr2);
		
		explosion_pompagr[i]->setAlign(ALIGN_CENTER);
		explosion_pompagr[i]->setVAlign(VALIGN_CENTER);
		explosion_pompagr[i]->selFrame(0);
		explosion_pompagr[i]->setActivo(0);
		
		explosion_pompapeq[i] = new Elemento(3);
		explosion_pompapeq[i]->addFrame(frExpPompaPeq0);
		explosion_pompapeq[i]->addFrame(frExpPompaPeq1);
		explosion_pompapeq[i]->addFrame(frExpPompaPeq2);
		
		explosion_pompapeq[i]->setAlign(ALIGN_CENTER);
		explosion_pompapeq[i]->setVAlign(VALIGN_CENTER);
		explosion_pompapeq[i]->selFrame(0);
		explosion_pompapeq[i]->setActivo(0);
		
	}
	
	// explosion de coches
	frExpCocheS0.loadFromRAR(tmpch, "exp_coche0.timp");	
	frExpCocheS1.loadFromRAR(tmpch, "exp_coche1.timp");		
	frExpCocheS2.loadFromRAR(tmpch, "exp_coche2.timp");	
	frExpCocheS3.loadFromRAR(tmpch, "exp_coche3.timp");	
	frExpCocheS4.loadFromRAR(tmpch, "exp_coche4.timp");		
	frExpCocheS5.loadFromRAR(tmpch, "exp_coche5.timp");
	frExpCocheS6.loadFromRAR(tmpch, "exp_coche6.timp");	
	frExpCocheS7.loadFromRAR(tmpch, "exp_coche7.timp");
	frExpCocheS8.loadFromRAR(tmpch, "exp_coche8.timp");
	
	for (i=0; i < MAXENE_CSIMPLE*2; i++) {
		explosion_coche[i] = new Elemento(9);
		explosion_coche[i]->addFrame(frExpCocheS0);
		explosion_coche[i]->addFrame(frExpCocheS1);
		explosion_coche[i]->addFrame(frExpCocheS2);
		explosion_coche[i]->addFrame(frExpCocheS3);
		explosion_coche[i]->addFrame(frExpCocheS4);
		explosion_coche[i]->addFrame(frExpCocheS5);
		explosion_coche[i]->addFrame(frExpCocheS6);
		explosion_coche[i]->addFrame(frExpCocheS7);
		explosion_coche[i]->addFrame(frExpCocheS8);
		
		explosion_coche[i]->setAlign(ALIGN_CENTER);
		explosion_coche[i]->setVAlign(VALIGN_CENTER);
		explosion_coche[i]->selFrame(0);
		explosion_coche[i]->setActivo(0);
	}
	
	// explosion barreras
	frBarrera0.loadFromRAR(tmpch, "exp_barrera0.timp");	
	frBarrera1.loadFromRAR(tmpch, "exp_barrera1.timp");		
	frBarrera2.loadFromRAR(tmpch, "exp_barrera2.timp");	
	frBarrera3.loadFromRAR(tmpch, "exp_barrera3.timp");	
	
	for (i=0; i < MAXENE_EXPBARRERAS; i++) {
		explosion_barrera[i] = new Elemento(4);
		explosion_barrera[i]->addFrame(frBarrera0);
		explosion_barrera[i]->addFrame(frBarrera1);
		explosion_barrera[i]->addFrame(frBarrera2);
		explosion_barrera[i]->addFrame(frBarrera3);
		
		explosion_barrera[i]->setAlign(ALIGN_CENTER);
		explosion_barrera[i]->setVAlign(VALIGN_CENTER);
		explosion_barrera[i]->selFrame(0);
		explosion_barrera[i]->setActivo(0);
	}
	
	// explosion mediana
	frExpMed0.loadFromRAR(tmpch, "exp_med0_0.timp");
	frExpMed1.loadFromRAR(tmpch, "exp_med0_1.timp");
	frExpMed2.loadFromRAR(tmpch, "exp_med0_2.timp");
	frExpMed3.loadFromRAR(tmpch, "exp_med0_3.timp");
	frExpMed4.loadFromRAR(tmpch, "exp_med0_4.timp");
	frExpMed5.loadFromRAR(tmpch, "exp_med0_5.timp");
	frExpMed6.loadFromRAR(tmpch, "exp_med0_6.timp");
	frExpMed7.loadFromRAR(tmpch, "exp_med0_7.timp");
	frExpMed8.loadFromRAR(tmpch, "exp_med0_8.timp");
	frExpMed9.loadFromRAR(tmpch, "exp_med0_9.timp");
	frExpMed10.loadFromRAR(tmpch, "exp_med0_10.timp");
	frExpMed11.loadFromRAR(tmpch, "exp_med0_11.timp");
	frExpMed12.loadFromRAR(tmpch, "exp_med0_12.timp");
	frExpMed13.loadFromRAR(tmpch, "exp_med0_13.timp");
	frExpMed14.loadFromRAR(tmpch, "exp_med0_14.timp");
	frExpMed15.loadFromRAR(tmpch, "exp_med0_15.timp");
	frExpMed16.loadFromRAR(tmpch, "exp_med0_16.timp");
	frExpMed17.loadFromRAR(tmpch, "exp_med0_17.timp");
	frExpMed18.loadFromRAR(tmpch, "exp_med0_18.timp");
	frExpMed19.loadFromRAR(tmpch, "exp_med0_19.timp");
	frExpMed20.loadFromRAR(tmpch, "exp_med0_20.timp");
	frExpMed21.loadFromRAR(tmpch, "exp_med0_21.timp");
	frExpMed22.loadFromRAR(tmpch, "exp_med0_22.timp");
	frExpMed23.loadFromRAR(tmpch, "exp_med0_23.timp");
	frExpMed24.loadFromRAR(tmpch, "exp_med0_24.timp");
	frExpMed25.loadFromRAR(tmpch, "exp_med0_25.timp");
	
	for (i=0; i < MAXEXP_MED; i++) {
		explosion_med[i] = new Elemento(26);
		explosion_med[i]->addFrame(frExpMed0);
		explosion_med[i]->addFrame(frExpMed1);
		explosion_med[i]->addFrame(frExpMed2);
		explosion_med[i]->addFrame(frExpMed3);
		explosion_med[i]->addFrame(frExpMed4);
		explosion_med[i]->addFrame(frExpMed5);
		explosion_med[i]->addFrame(frExpMed6);
		explosion_med[i]->addFrame(frExpMed7);
		explosion_med[i]->addFrame(frExpMed8);
		explosion_med[i]->addFrame(frExpMed9);
		explosion_med[i]->addFrame(frExpMed10);
		explosion_med[i]->addFrame(frExpMed11);
		explosion_med[i]->addFrame(frExpMed12);
		explosion_med[i]->addFrame(frExpMed13);
		explosion_med[i]->addFrame(frExpMed14);
		explosion_med[i]->addFrame(frExpMed15);
		explosion_med[i]->addFrame(frExpMed16);
		explosion_med[i]->addFrame(frExpMed17);
		explosion_med[i]->addFrame(frExpMed18);
		explosion_med[i]->addFrame(frExpMed19);
		explosion_med[i]->addFrame(frExpMed20);
		explosion_med[i]->addFrame(frExpMed21);
		explosion_med[i]->addFrame(frExpMed22);
		explosion_med[i]->addFrame(frExpMed23);
		explosion_med[i]->addFrame(frExpMed24);
		explosion_med[i]->addFrame(frExpMed25);
		
		explosion_med[i]->setAlign(ALIGN_CENTER);
		explosion_med[i]->setVAlign(VALIGN_CENTER);
		explosion_med[i]->selFrame(0);
		explosion_med[i]->setActivo(0);
	}
	
	// explosion tanque
	
	frExpMed23.loadFromRAR(tmpch, "exp_tanque23.timp");

	
	for (i=0; i < MAXENE_TANQUE; i++) {
		explosion_tanque[i] = new Elemento(24);
		explosion_tanque[i]->addFrame(frExpMed0);
		explosion_tanque[i]->addFrame(frExpMed1);
		explosion_tanque[i]->addFrame(frExpMed2);
		explosion_tanque[i]->addFrame(frExpMed3);
		explosion_tanque[i]->addFrame(frExpMed4);
		explosion_tanque[i]->addFrame(frExpMed5);
		explosion_tanque[i]->addFrame(frExpMed6);
		explosion_tanque[i]->addFrame(frExpMed7);
		explosion_tanque[i]->addFrame(frExpMed8);
		explosion_tanque[i]->addFrame(frExpMed9);
		explosion_tanque[i]->addFrame(frExpMed10);
		explosion_tanque[i]->addFrame(frExpMed11);
		explosion_tanque[i]->addFrame(frExpMed12);
		explosion_tanque[i]->addFrame(frExpMed13);
		explosion_tanque[i]->addFrame(frExpMed14);
		explosion_tanque[i]->addFrame(frExpMed15);
		explosion_tanque[i]->addFrame(frExpMed16);
		explosion_tanque[i]->addFrame(frExpMed17);
		explosion_tanque[i]->addFrame(frExpMed18);
		explosion_tanque[i]->addFrame(frExpMed19);
		explosion_tanque[i]->addFrame(frExpMed20);
		explosion_tanque[i]->addFrame(frExpMed21);
		explosion_tanque[i]->addFrame(frExpMed22);
		explosion_tanque[i]->addFrame(frExpMed23);
		
		explosion_tanque[i]->setAlign(ALIGN_CENTER);
		explosion_tanque[i]->setVAlign(VALIGN_CENTER);
		explosion_tanque[i]->selFrame(0);
		explosion_tanque[i]->setActivo(0);
	}
	
	
	// explosion mediana1
	frExpMed0.loadFromRAR(tmpch, "exp_med1_0.timp");
	frExpMed1.loadFromRAR(tmpch, "exp_med1_1.timp");
	frExpMed2.loadFromRAR(tmpch, "exp_med1_2.timp");
	frExpMed3.loadFromRAR(tmpch, "exp_med1_3.timp");
	frExpMed4.loadFromRAR(tmpch, "exp_med1_4.timp");
	frExpMed5.loadFromRAR(tmpch, "exp_med1_5.timp");
	frExpMed6.loadFromRAR(tmpch, "exp_med1_6.timp");
	frExpMed7.loadFromRAR(tmpch, "exp_med1_7.timp");
	frExpMed8.loadFromRAR(tmpch, "exp_med1_8.timp");
	frExpMed9.loadFromRAR(tmpch, "exp_med1_9.timp");
	frExpMed10.loadFromRAR(tmpch, "exp_med1_10.timp");
	frExpMed11.loadFromRAR(tmpch, "exp_med1_11.timp");
	frExpMed12.loadFromRAR(tmpch, "exp_med1_12.timp");
	frExpMed13.loadFromRAR(tmpch, "exp_med1_13.timp");
	frExpMed14.loadFromRAR(tmpch, "exp_med1_14.timp");
	frExpMed15.loadFromRAR(tmpch, "exp_med1_15.timp");
	frExpMed16.loadFromRAR(tmpch, "exp_med1_16.timp");
	frExpMed17.loadFromRAR(tmpch, "exp_med1_17.timp");
	frExpMed18.loadFromRAR(tmpch, "exp_med1_18.timp");
	frExpMed19.loadFromRAR(tmpch, "exp_med1_19.timp");
	frExpMed20.loadFromRAR(tmpch, "exp_med1_20.timp");
	frExpMed21.loadFromRAR(tmpch, "exp_med1_21.timp");
	frExpMed22.loadFromRAR(tmpch, "exp_med1_22.timp");
	frExpMed23.loadFromRAR(tmpch, "exp_med1_23.timp");
	frExpMed24.loadFromRAR(tmpch, "exp_med1_24.timp");
	frExpMed25.loadFromRAR(tmpch, "exp_med1_25.timp");
	frExpMed26.loadFromRAR(tmpch, "exp_torre.timp");	
	
	for (i=0; i < MAXEXP_MED; i++) {
		explosion_med1[i] = new Elemento(27);
		explosion_med1[i]->addFrame(frExpMed0);
		explosion_med1[i]->addFrame(frExpMed1);
		explosion_med1[i]->addFrame(frExpMed2);
		explosion_med1[i]->addFrame(frExpMed3);
		explosion_med1[i]->addFrame(frExpMed4);
		explosion_med1[i]->addFrame(frExpMed5);
		explosion_med1[i]->addFrame(frExpMed6);
		explosion_med1[i]->addFrame(frExpMed7);
		explosion_med1[i]->addFrame(frExpMed8);
		explosion_med1[i]->addFrame(frExpMed9);
		explosion_med1[i]->addFrame(frExpMed10);
		explosion_med1[i]->addFrame(frExpMed11);
		explosion_med1[i]->addFrame(frExpMed12);
		explosion_med1[i]->addFrame(frExpMed13);
		explosion_med1[i]->addFrame(frExpMed14);
		explosion_med1[i]->addFrame(frExpMed15);
		explosion_med1[i]->addFrame(frExpMed16);
		explosion_med1[i]->addFrame(frExpMed17);
		explosion_med1[i]->addFrame(frExpMed18);
		explosion_med1[i]->addFrame(frExpMed19);
		explosion_med1[i]->addFrame(frExpMed20);
		explosion_med1[i]->addFrame(frExpMed21);
		explosion_med1[i]->addFrame(frExpMed22);
		explosion_med1[i]->addFrame(frExpMed23);
		explosion_med1[i]->addFrame(frExpMed24);
		explosion_med1[i]->addFrame(frExpMed25);
		explosion_med1[i]->addFrame(frExpMed26);
		
		explosion_med1[i]->setAlign(ALIGN_CENTER);
		explosion_med1[i]->setVAlign(VALIGN_CENTER);
		explosion_med1[i]->selFrame(0);
		explosion_med1[i]->setActivo(0);
	}
	
	

	// explosion grande
	frExpGr0.loadFromRAR(tmpch, "expgr0_0.timp");
	frExpGr1.loadFromRAR(tmpch, "expgr0_1.timp");
	frExpGr2.loadFromRAR(tmpch, "expgr0_2.timp");
	frExpGr3.loadFromRAR(tmpch, "expgr0_3.timp");
	frExpGr4.loadFromRAR(tmpch, "expgr0_4.timp");
	frExpGr5.loadFromRAR(tmpch, "expgr0_5.timp");
	frExpGr6.loadFromRAR(tmpch, "expgr0_6.timp");
	frExpGr7.loadFromRAR(tmpch, "expgr0_7.timp");
	frExpGr8.loadFromRAR(tmpch, "expgr0_8.timp");
	frExpGr9.loadFromRAR(tmpch, "expgr0_9.timp");
	frExpGr10.loadFromRAR(tmpch, "expgr0_10.timp");
	frExpGr11.loadFromRAR(tmpch, "expgr0_11.timp");
	frExpGr12.loadFromRAR(tmpch, "expgr0_12.timp");
	frExpGr13.loadFromRAR(tmpch, "expgr0_13.timp");
	frExpGr14.loadFromRAR(tmpch, "expgr0_14.timp");
	frExpGr15.loadFromRAR(tmpch, "expgr0_15.timp");
	frExpGr16.loadFromRAR(tmpch, "expgr0_16.timp");
	frExpGr17.loadFromRAR(tmpch, "expgr0_17.timp");
	frExpGr18.loadFromRAR(tmpch, "expgr0_18.timp");
	frExpGr19.loadFromRAR(tmpch, "expgr0_19.timp");
	frExpGr20.loadFromRAR(tmpch, "expgr0_20.timp");
	frExpGr21.loadFromRAR(tmpch, "expgr0_21.timp");
	frExpGr22.loadFromRAR(tmpch, "expgr0_22.timp");
	frExpGr23.loadFromRAR(tmpch, "expgr0_23.timp");
	frExpGr24.loadFromRAR(tmpch, "expgr0_24.timp");
	frExpGr25.loadFromRAR(tmpch, "expgr0_25.timp");
	frExpGr26.loadFromRAR(tmpch, "expgr0_26.timp");
	frExpGr27.loadFromRAR(tmpch, "expgr0_27.timp");
	frExpGr28.loadFromRAR(tmpch, "expgr0_28.timp");
	frExpGr29.loadFromRAR(tmpch, "expgr0_29.timp");
	frExpGr30.loadFromRAR(tmpch, "expgr0_30.timp");
	frExpGr31.loadFromRAR(tmpch, "expgr0_31.timp");
	frExpGr32.loadFromRAR(tmpch, "expgr0_32.timp");
	frExpGr33.loadFromRAR(tmpch, "expgr0_33.timp");
	frExpGr34.loadFromRAR(tmpch, "expgr0_34.timp");
	frExpGr35.loadFromRAR(tmpch, "expgr0_35.timp");
	frExpGr36.loadFromRAR(tmpch, "expgr0_36.timp");
	
	
	for (i=0; i < MAXEXP_GR; i++) {
		explosion_gr0[i] = new Elemento(37);
		explosion_gr0[i]->addFrame(frExpGr0);
		explosion_gr0[i]->addFrame(frExpGr1);
		explosion_gr0[i]->addFrame(frExpGr2);
		explosion_gr0[i]->addFrame(frExpGr3);
		explosion_gr0[i]->addFrame(frExpGr4);
		explosion_gr0[i]->addFrame(frExpGr5);
		explosion_gr0[i]->addFrame(frExpGr6);
		explosion_gr0[i]->addFrame(frExpGr7);
		explosion_gr0[i]->addFrame(frExpGr8);
		explosion_gr0[i]->addFrame(frExpGr9);
		explosion_gr0[i]->addFrame(frExpGr10);
		explosion_gr0[i]->addFrame(frExpGr11);
		explosion_gr0[i]->addFrame(frExpGr12);
		explosion_gr0[i]->addFrame(frExpGr13);
		explosion_gr0[i]->addFrame(frExpGr14);
		explosion_gr0[i]->addFrame(frExpGr15);
		explosion_gr0[i]->addFrame(frExpGr16);
		explosion_gr0[i]->addFrame(frExpGr17);
		explosion_gr0[i]->addFrame(frExpGr18);
		explosion_gr0[i]->addFrame(frExpGr19);
		explosion_gr0[i]->addFrame(frExpGr20);
		explosion_gr0[i]->addFrame(frExpGr21);
		explosion_gr0[i]->addFrame(frExpGr22);
		explosion_gr0[i]->addFrame(frExpGr23);
		explosion_gr0[i]->addFrame(frExpGr24);
		explosion_gr0[i]->addFrame(frExpGr25);
		explosion_gr0[i]->addFrame(frExpGr26);
		explosion_gr0[i]->addFrame(frExpGr27);
		explosion_gr0[i]->addFrame(frExpGr28);
		explosion_gr0[i]->addFrame(frExpGr29);
		explosion_gr0[i]->addFrame(frExpGr30);
		explosion_gr0[i]->addFrame(frExpGr31);
		explosion_gr0[i]->addFrame(frExpGr32);
		explosion_gr0[i]->addFrame(frExpGr33);
		explosion_gr0[i]->addFrame(frExpGr34);
		explosion_gr0[i]->addFrame(frExpGr35);
		explosion_gr0[i]->addFrame(frExpGr36);
		
		explosion_gr0[i]->setAlign(ALIGN_CENTER);
		explosion_gr0[i]->setVAlign(VALIGN_CENTER);
		explosion_gr0[i]->selFrame(0);
		explosion_gr0[i]->setActivo(0);
	}
	
	
	iniciar();
 }
 
 int Explosion::elementoLibre (int ele) {
	int i;
	int libre = -1;
	switch (ele) {
		case EXP_GAVIOTA1:
			for (i=0; i < MAXENE_GEN1; i++) {
				if (explosion_gav1[i]->getActivo() == 0) {
					libre = i;
				}
			}			
		break;
		case EXP_GAVIOTA2:
			for (i=0; i < MAXENE_GEN1; i++) {
				if (explosion_gav2[i]->getActivo() == 0) {
					libre = i;
				}
			}			
		break;
		case EXP_NAVEPEQUENYA:
			for (i=0; i < MAXENE_GEN1; i++) {
				if (explosion_navepeq[i]->getActivo() == 0) {
					libre = i;
				}
			}			
		break;
		case EXP_NAVEMED:
			for (i=0; i < MAXENE_GEN2*2; i++) {
				if (explosion_navemed[i]->getActivo() == 0) {
					libre = i;
				}
			}			
		break;
		case EXP_NAVEGRANDE:
			for (i=0; i < MAXENE_GEN3*2; i++) {
				if (explosion_navegr[i]->getActivo() == 0) {
					libre = i;
				}
			}			
		break;
		case EXP_DISPARO_GR:
			for (i=0; i < MAXDISP_GR; i++) {
				if (explosion_dispgr[i]->getActivo() == 0) {
					libre = i;
				}
			}			
		break;
		case EXP_DISPARO_GR_AZUL:
			for (i=0; i < MAXDISP_GR; i++) {
				if (explosion_dispgr_azul[i]->getActivo() == 0) {
					libre = i;
				}
			}
		break;
		case EXP_CANGREBOT:
			for (i=0; i < MAXENE_MARINOS; i++) {
				if (explosion_cangrebot[i]->getActivo() == 0) {
					libre = i;
				}
			}			
		break;
		case EXP_PULPO:
			for (i=0; i < MAXENE_MARINOS; i++) {
				if (explosion_pulpo[i]->getActivo() == 0) {
					libre = i;
				}
			}			
		break;
		case EXP_LANCHA:
			for (i=0; i < MAXENE_AUTOMARINO; i++) {
				if (explosion_lancha[i]->getActivo() == 0) {
					libre = i;
				}
			}			
		break;
		case EXP_CASETA:
			for (i=0; i < MAXENE_CONSTRUCCIONES; i++) {
				if (explosion_caseta[i]->getActivo() == 0) {
					libre = i;
				}
			}			
		break;
		case EXP_POMPAGR:
			for (i=0; i < MAXDISP_POMPA; i++) {
				if (explosion_pompagr[i]->getActivo() == 0) {
					libre = i;
				}
			}			
		break;
		case EXP_POMPAPEQ:
			for (i=0; i < MAXDISP_POMPA; i++) {
				if (explosion_pompapeq[i]->getActivo() == 0) {
					libre = i;
				}
			}			
		break;
		case EXP_COCHE:
		case EXP_COCHE_CORTA:
			for (i=0; i < MAXENE_CSIMPLE*2; i++) {
				if (explosion_coche[i]->getActivo() == 0) {
					libre = i;
				}
			}			
		break;
		case EXP_MEDIANA:
			for (i=0; i < MAXEXP_MED; i++) {
				if (explosion_med[i]->getActivo() == 0) {
					libre = i;
				}
			}			
		break;
		case EXP_MEDIANA1:
			for (i=0; i < MAXEXP_MED; i++) {
				if (explosion_med1[i]->getActivo() == 0) {
					libre = i;
				}
			}			
		break;
		case EXP_TORRE:
			for (i=0; i < MAXEXP_MED; i++) {
				if (explosion_med1[i]->getActivo() == 0) {
					libre = i;
				}
			}			
		break;
		case EXP_GRANDE:
			for (i=0; i < MAXEXP_GR; i++) {
				if (explosion_gr0[i]->getActivo() == 0) {
					libre = i;
				}
			}
		break;
		case EXP_BARRERA:
			for (i=0; i < MAXENE_EXPBARRERAS; i++) {
				if (explosion_barrera[i]->getActivo() == 0) {
					libre = i;
				}
			}
		break;
		case EXP_TANQUE:
			for (i=0; i < MAXENE_TANQUE; i++) {
				if (explosion_tanque[i]->getActivo() == 0) {
					libre = i;
				}
			}
		break;
		case EXP_YATE:
			for (i=0; i < MAXENE_YATE; i++) {
				if (explosion_yate[i]->getActivo() == 0) {
					libre = i;
				}
			}
		break;
	}
	return libre;
}

 void Explosion::crearExplosion (int ele, float x, float y) {
	int l = elementoLibre(ele);

	switch (ele) {
		case EXP_GAVIOTA1:
			 if ( l != -1 ) {
				explosion_gav1[l]->setActivo(1);
				explosion_gav1[l]->setX(x);
				explosion_gav1[l]->setY(y);
				explosion_gav1[l]->selFrame(0);
			}
		break;
		case EXP_GAVIOTA2:
			 if ( l != -1 ) {
				explosion_gav2[l]->setActivo(1);
				explosion_gav2[l]->setX(x);
				explosion_gav2[l]->setY(y);
				explosion_gav2[l]->selFrame(0);
			}
		break;
		case EXP_NAVEPEQUENYA:
			 if ( l != -1 ) {
				explosion_navepeq[l]->setActivo(1);
				explosion_navepeq[l]->setX(x);
				explosion_navepeq[l]->setY(y);
				explosion_navepeq[l]->selFrame(0);
			}
		break;
		case EXP_NAVEMED:
			 if ( l != -1 ) {
				explosion_navemed[l]->setActivo(1);
				explosion_navemed[l]->setX(x);
				explosion_navemed[l]->setY(y);
				explosion_navemed[l]->selFrame(0);
			}
		break;
		case EXP_NAVEGRANDE:
			 if ( l != -1 ) {
				explosion_navegr[l]->setActivo(1);
				explosion_navegr[l]->setX(x);
				explosion_navegr[l]->setY(y);
				explosion_navegr[l]->selFrame(0);
			}
		break;
		case EXP_DISPARO_GR:
			 if ( l != -1 ) {
				explosion_dispgr[l]->setActivo(1);
				explosion_dispgr[l]->setX(x);
				explosion_dispgr[l]->setY(y);
				explosion_dispgr[l]->selFrame(0);
			}
		break;
		case EXP_DISPARO_GR_AZUL:
			 if ( l != -1 ) {
				explosion_dispgr_azul[l]->setActivo(1);
				explosion_dispgr_azul[l]->setX(x);
				explosion_dispgr_azul[l]->setY(y);
				explosion_dispgr_azul[l]->selFrame(0);
			}
		break;
		case EXP_CANGREBOT:
			 if ( l != -1 ) {
				explosion_cangrebot[l]->setActivo(1);
				explosion_cangrebot[l]->setX(x);
				explosion_cangrebot[l]->setY(y);
				explosion_cangrebot[l]->selFrame(0);
			}
		break;
		case EXP_PULPO:
			 if ( l != -1 ) {
				explosion_pulpo[l]->setActivo(1);
				explosion_pulpo[l]->setX(x);
				explosion_pulpo[l]->setY(y);
				explosion_pulpo[l]->selFrame(0);
			}
		break;
		case EXP_LANCHA:
			 if ( l != -1 ) {
				explosion_lancha[l]->setActivo(1);
				explosion_lancha[l]->setX(x);
				explosion_lancha[l]->setY(y);
				explosion_lancha[l]->selFrame(0);
			}
		break;
		case EXP_CASETA:
			 if ( l != -1 ) {
				explosion_caseta[l]->setActivo(1);
				explosion_caseta[l]->setX(x);
				explosion_caseta[l]->setY(y);
				explosion_caseta[l]->selFrame(0);
			}
		break;
		case EXP_POMPAGR:
			 if ( l != -1 ) {
				explosion_pompagr[l]->setActivo(1);
				explosion_pompagr[l]->setX(x);
				explosion_pompagr[l]->setY(y);
				explosion_pompagr[l]->selFrame(0);
			}
		break;
		case EXP_POMPAPEQ:
			 if ( l != -1 ) {
				explosion_pompapeq[l]->setActivo(1);
				explosion_pompapeq[l]->setX(x);
				explosion_pompapeq[l]->setY(y);
				explosion_pompapeq[l]->selFrame(0);
			}
		break;
		case EXP_COCHE:
			 if ( l != -1 ) {
				explosion_coche[l]->setActivo(1);
				explosion_coche[l]->selFrame(0);
				explosion_coche[l]->setX( x );
				explosion_coche[l]->setY( y );
				explosion_coche[l]->selFrame(0);
			}
		break;
		case EXP_COCHE_CORTA:
			 if ( l != -1 ) {
				explosion_coche[l]->setActivo(1);
				explosion_coche[l]->setTipoElemento(EXP_COCHE_CORTA);
				explosion_coche[l]->setX( x );
				explosion_coche[l]->setY( y );
				explosion_coche[l]->selFrame(0);
			}
		break;
		case EXP_MEDIANA:
			 if ( l != -1 ) {
				explosion_med[l]->setActivo(1);
				explosion_med[l]->setX( x );
				explosion_med[l]->setY( y );
				explosion_med[l]->selFrame(0);
			}
		break;
		case EXP_MEDIANA1:
			 if ( l != -1 ) {
				explosion_med1[l]->setActivo(1);
				explosion_med1[l]->setX( x );
				explosion_med1[l]->setY( y );
				explosion_med1[l]->selFrame(0);
			}
		break;
		case EXP_TORRE:
			 if ( l != -1 ) {
				explosion_med1[l]->setActivo(1);
				explosion_med1[l]->setTipoElemento(EXP_TORRE);
				explosion_med1[l]->setX( x );
				explosion_med1[l]->setY( y );
				explosion_med1[l]->selFrame(0);
			}
		break;
		case EXP_GRANDE:
			 if ( l != -1 ) {
				explosion_gr0[l]->setActivo(1);
				explosion_gr0[l]->setX( x );
				explosion_gr0[l]->setY( y );
				explosion_gr0[l]->selFrame(0);
			}
		break;
		case EXP_BARRERA:
			 if ( l != -1 ) {
				explosion_barrera[l]->setActivo(1);
				explosion_barrera[l]->setX( x );
				explosion_barrera[l]->setY( y );
				explosion_barrera[l]->selFrame(0);
			}
		break;
		case EXP_TANQUE:
			 if ( l != -1 ) {
				explosion_tanque[l]->setActivo(1);
				explosion_tanque[l]->setX( x );
				explosion_tanque[l]->setY( y );
				explosion_tanque[l]->selFrame(0);
			}
		break;
		case EXP_YATE:
			 if ( l != -1 ) {
				explosion_yate[l]->setActivo(1);
				explosion_yate[l]->setX( x );
				explosion_yate[l]->setY( y );
				explosion_yate[l]->selFrame(0);
			}
		break;
		}
}

void Explosion::dibujarExplosionTierra(SDL_Surface *screen) {
	int i, pfr;
	
	ciclos++;
	
	if (explosionJefe.activo) {
		if (explosionJefe.jefeFase == 1) {
			cangrejo->setX(explosionJefe.x+30); 
			cangrejo->setY(explosionJefe.y+45); 
			cangrejo->dibujar(screen);
		}
		if (explosionJefe.jefeFase == 2) {
			purpo->setX(explosionJefe.x+30); 
			purpo->setY(explosionJefe.y+45); 
			purpo->dibujar(screen);
		}
		dibujarExplosionJefe();
	}

	// explosiones de los cangrebot y pulpo
	for (i=0; i < MAXENE_MARINOS; i++) {
		if (explosion_cangrebot[i]->getActivo() == 1) {
			explosion_cangrebot[i]->addY(VEL_MAPA);
			explosion_cangrebot[i]->dibujar(screen);
			if (ciclos % 2 == 0) {
				pfr = explosion_cangrebot[i]->getActualFrame() + 1;
				if (explosion_cangrebot[i]->getActualFrame() > 7) {
					explosion_cangrebot[i]->setActivo(0);
					explosion_cangrebot[i]->selFrame(0);
				} else {
					explosion_cangrebot[i]->selFrame(pfr);
				}
			}
		}
		if (explosion_pulpo[i]->getActivo() == 1) {
			explosion_pulpo[i]->addY(VEL_MAPA);
			explosion_pulpo[i]->dibujar(screen);
			if (ciclos % 3 == 0) {
				pfr = explosion_pulpo[i]->getActualFrame() + 1;
				if (explosion_pulpo[i]->getActualFrame() > 6) {
					explosion_pulpo[i]->setActivo(0);
					explosion_pulpo[i]->selFrame(0);
				} else {
					explosion_pulpo[i]->selFrame(pfr);
				}
			}
		}
	}
	
	// explosiones de las lanchas
	for (i=0; i < MAXENE_AUTOMARINO; i++) {
		if (explosion_lancha[i]->getActivo() == 1) {
			explosion_lancha[i]->dibujar(screen);
			if (ciclos % 2 == 0) {
				pfr = explosion_lancha[i]->getActualFrame() + 1;
				if (explosion_lancha[i]->getActualFrame() > 7) {
					explosion_lancha[i]->setActivo(0);
					explosion_lancha[i]->selFrame(0);
				} else {
					explosion_lancha[i]->selFrame(pfr);
				}
			}
		}
	}
	
	// explosiones de los yates
	for (i=0; i < MAXENE_YATE; i++) {
		if (explosion_yate[i]->getActivo() == 1) {
			explosion_yate[i]->addY(VEL_MAPA);
			explosion_yate[i]->dibujar(screen);
			if (ciclos % 2 == 0) {
				pfr = explosion_yate[i]->getActualFrame() + 1;
				if (explosion_yate[i]->getActualFrame() > 8) {
					explosion_yate[i]->setActivo(0);
					explosion_yate[i]->selFrame(0);
				} else {
					explosion_yate[i]->selFrame(pfr);
				}
			}
		}
	}
	
	// explosiones de las casetas
	for (i=0; i < MAXENE_CONSTRUCCIONES; i++) {
		if (explosion_caseta[i]->getActivo() == 1) {
			explosion_caseta[i]->addY(VEL_MAPA);
			explosion_caseta[i]->dibujar(screen);
			if (ciclos % 2 == 0) {
				pfr = explosion_caseta[i]->getActualFrame() + 1;
				if (explosion_caseta[i]->getActualFrame() > 6) {
					explosion_caseta[i]->selFrame(7);
					if (explosion_caseta[i]->fueraLimitesDePantalla()) {
						explosion_caseta[i]->setActivo(0);
						explosion_caseta[i]->selFrame(0);
					}
				} else {
					explosion_caseta[i]->selFrame(pfr);
				}
			}
		}
	}
	
	// explosiones de las barreras
	for (i=0; i < MAXENE_EXPBARRERAS; i++) {
		if (explosion_barrera[i]->getActivo() == 1) {
			explosion_barrera[i]->addY(VEL_MAPA);
			explosion_barrera[i]->dibujar(screen);
			if (ciclos % 3 == 0) {
				pfr = explosion_barrera[i]->getActualFrame() + 1;
				if (explosion_barrera[i]->getActualFrame() > 2) {
					explosion_barrera[i]->selFrame(3);
					if (explosion_barrera[i]->fueraLimitesDePantalla()) {
						explosion_barrera[i]->setActivo(0);
						explosion_barrera[i]->selFrame(0);
					}
				} else {
					explosion_barrera[i]->selFrame(pfr);
				}
			}
		}
	}
	
	
	// explosiones de los coches
	
	for (i=0; i < MAXENE_CSIMPLE*2; i++) {
		if (explosion_coche[i]->getActivo() == 1) {
			if (explosion_coche[i]->getActualFrame() >= 7) {
				if (explosion_coche[i]->getTipoElemento() != EXP_COCHE_CORTA) {
					explosion_coche[i]->selFrame(8);
					if (explosion_coche[i]->fueraLimitesDePantalla()) {
						explosion_coche[i]->setActivo(0);
						explosion_coche[i]->selFrame(0);
					} else {
						explosion_coche[i]->addY(VEL_MAPA);
						explosion_coche[i]->dibujar(screen);
					}
				} else {
					explosion_coche[i]->setTipoElemento(0);
					explosion_coche[i]->setActivo(0);
					explosion_coche[i]->selFrame(0);
				}
			}
		}

	}

	for (i=0; i < MAXENE_CSIMPLE*2; i++) {
		if (explosion_coche[i]->getActivo() == 1) {
			if (explosion_coche[i]->getActualFrame() < 7) {
				if (ciclos % 2 == 0) {
					explosion_coche[i]->selSiguienteFrame();
				}
				if (explosion_coche[i]->getTipoElemento() != EXP_COCHE_CORTA) explosion_coche[i]->addY(VEL_MAPA);
				explosion_coche[i]->dibujar(screen);
			}
		}
	}
	
	// explosiones del tanque
	for (i=0; i < MAXENE_TANQUE; i++) {
		if (explosion_tanque[i]->getActivo() == 1) {
			explosion_tanque[i]->addY(VEL_MAPA);
			explosion_tanque[i]->dibujar(screen);
			if (ciclos % 2 == 0) {
				pfr = explosion_tanque[i]->getActualFrame() + 1;
				if (explosion_tanque[i]->getActualFrame() > 22) {
					explosion_tanque[i]->selFrame(23);
					if (explosion_tanque[i]->fueraLimitesDePantalla()) {
						explosion_tanque[i]->setActivo(0);
						explosion_tanque[i]->selFrame(0);
					}
				} else {
					explosion_tanque[i]->selFrame(pfr);
				}
			}
		}
	}
	

	// explosiones grandes
	for (i=0; i < MAXEXP_GR; i++) {
		if (explosion_gr0[i]->getActivo() == 1) {
			explosion_gr0[i]->addY(2);
			explosion_gr0[i]->dibujar(screen);
			//if (ciclos % 2 == 0) {
				pfr = explosion_gr0[i]->getActualFrame() + 1;
				if (explosion_gr0[i]->getActualFrame() > 24) {
					explosion_gr0[i]->setActivo(0);
					explosion_gr0[i]->selFrame(0);
				} else {
					explosion_gr0[i]->selFrame(pfr);
				}
			//}
		}
	}
	
}

void Explosion::dibujarExplosionJefe() {
	
	if ( (ciclos%30 == 0) || (explosionJefe.swExplotar) ) {
		explosionJefe.swExplotar = false;
		crearExplosion(EXP_MEDIANA, explosionJefe.x+90, explosionJefe.y+80);
		//crearExplosion(EXP_GRANDE, explosionJefe1.x+250, explosionJefe1.y+80);
		crearExplosion(EXP_MEDIANA1, explosionJefe.x+100, explosionJefe.y+100);
		//crearExplosion(EXP_NAVEMED, explosionJefe1.x+50, explosionJefe1.y+170);
		crearExplosion(EXP_NAVEMED, explosionJefe.x+90, explosionJefe.y+100);
		//crearExplosion(EXP_NAVEGRANDE, explosionJefe1.x+120, explosionJefe1.y+30);
		crearExplosion(EXP_MEDIANA, explosionJefe.x+230, explosionJefe.y+160);
		if (explosionJefe.jefeFase==2) {
			crearExplosion(EXP_MEDIANA, explosionJefe.x+260, explosionJefe.y+190);
		}
	}
	if (ciclos%45 == 0) {
		crearExplosion(EXP_GRANDE, explosionJefe.x+90, explosionJefe.y+130);
		//crearExplosion(EXP_NAVEGRANDE, explosionJefe1.x+180, explosionJefe1.y+140);
		//crearExplosion(EXP_MEDIANA, explosionJefe1.x+240, explosionJefe1.y+140);
		crearExplosion(EXP_MEDIANA1, explosionJefe.x+210, explosionJefe.y+110);
		//crearExplosion(EXP_NAVEMED, explosionJefe1.x+160, explosionJefe1.y+200);
		if (explosionJefe.jefeFase==2) {
			crearExplosion(EXP_MEDIANA1, explosionJefe.x+250, explosionJefe.y+190);
		}
	}
}


void Explosion::dibujarExplosionAire(SDL_Surface *screen) {
	int i, pfr;
	
	// explosiones de los gaviotas1
	for (i=0; i < MAXENE_GEN1; i++) {
		if (explosion_gav1[i]->getActivo() == 1) {
			explosion_gav1[i]->dibujar(screen);
			pfr = explosion_gav1[i]->getActualFrame() + 1;
			if (explosion_gav1[i]->getActualFrame() > 4) {
				explosion_gav1[i]->setActivo(0);
				explosion_gav1[i]->selFrame(0);
			} else {
				explosion_gav1[i]->selFrame(pfr);
			}
		}
	}
	
	// explosiones de los gaviotas2
	for (i=0; i < MAXENE_GEN1; i++) {
		if (explosion_gav2[i]->getActivo() == 1) {
			explosion_gav2[i]->dibujar(screen);
			pfr = explosion_gav2[i]->getActualFrame() + 1;
			if (explosion_gav2[i]->getActualFrame() > 4) {
				explosion_gav2[i]->setActivo(0);
				explosion_gav2[i]->selFrame(0);
			} else {
				explosion_gav2[i]->selFrame(pfr);
			}
		}
	}
	
	// explosiones de las naves pequeñas
	for (i=0; i < MAXENE_GEN1; i++) {
		if (explosion_navepeq[i]->getActivo() == 1) {
			explosion_navepeq[i]->dibujar(screen);
			pfr = explosion_navepeq[i]->getActualFrame() + 1;
			if (explosion_navepeq[i]->getActualFrame() > 6) {
				explosion_navepeq[i]->setActivo(0);
				explosion_navepeq[i]->selFrame(0);
			} else {
				explosion_navepeq[i]->selFrame(pfr);
			}
		}
	}
	
	// explosiones de las naves mediana
	for (i=0; i < MAXENE_GEN2*2; i++) {
		if (explosion_navemed[i]->getActivo() == 1) {
			explosion_navemed[i]->dibujar(screen);
			if (ciclos % 2 == 0) {
				pfr = explosion_navemed[i]->getActualFrame() + 1;
				if (explosion_navemed[i]->getActualFrame() > 6) {
					explosion_navemed[i]->setActivo(0);
					explosion_navemed[i]->selFrame(0);
				} else {
					explosion_navemed[i]->selFrame(pfr);
				}
			}
		}
	}
	
	// explosiones de las naves grandes
	for (i=0; i < MAXENE_GEN3*2; i++) {
		if (explosion_navegr[i]->getActivo() == 1) {
			explosion_navegr[i]->dibujar(screen);
			if (ciclos % 2 == 0) {
				pfr = explosion_navegr[i]->getActualFrame() + 1;
				if (explosion_navegr[i]->getActualFrame() > 6) {
					explosion_navegr[i]->setActivo(0);
					explosion_navegr[i]->selFrame(0);
				} else {
					explosion_navegr[i]->selFrame(pfr);
				}
			}
		}
	}
	
	// explosiones de las balas grandes
	for (i=0; i < MAXDISP_GR; i++) {
		if (explosion_dispgr[i]->getActivo() == 1) {
			explosion_dispgr[i]->dibujar(screen);
			pfr = explosion_dispgr[i]->getActualFrame() + 1;
			if (explosion_dispgr[i]->getActualFrame() > 2) {
				explosion_dispgr[i]->setActivo(0);
				explosion_dispgr[i]->selFrame(0);
			} else {
				explosion_dispgr[i]->selFrame(pfr);
			}
		}
		if (explosion_dispgr_azul[i]->getActivo() == 1) {
			explosion_dispgr_azul[i]->dibujar(screen);
			pfr = explosion_dispgr_azul[i]->getActualFrame() + 1;
			if (explosion_dispgr_azul[i]->getActualFrame() > 2) {
				explosion_dispgr_azul[i]->setActivo(0);
				explosion_dispgr_azul[i]->selFrame(0);
			} else {
				explosion_dispgr_azul[i]->selFrame(pfr);
			}
		}
	}
	
	// explosiones de las pompas 
	for (i=0; i < MAXDISP_POMPA; i++) {
		if (explosion_pompagr[i]->getActivo() == 1) {
			explosion_pompagr[i]->dibujar(screen);
			pfr = explosion_pompagr[i]->getActualFrame() + 1;
			if (explosion_pompagr[i]->getActualFrame() > 1) {
				explosion_pompagr[i]->setActivo(0);
				explosion_pompagr[i]->selFrame(0);
			} else {
				explosion_pompagr[i]->selFrame(pfr);
			}
		}
		
		if (explosion_pompapeq[i]->getActivo() == 1) {
			explosion_pompapeq[i]->dibujar(screen);
			pfr = explosion_pompapeq[i]->getActualFrame() + 1;
			if (explosion_pompapeq[i]->getActualFrame() > 1) {
				explosion_pompapeq[i]->setActivo(0);
				explosion_pompapeq[i]->selFrame(0);
			} else {
				explosion_pompapeq[i]->selFrame(pfr);
			}
		}
		
	}

	// explosiones medianas
	for (i=0; i < MAXEXP_MED; i++) {
		if (explosion_med[i]->getActivo() == 1) {
			explosion_med[i]->addY(2);
			explosion_med[i]->dibujar(screen);
			if (ciclos % 2 == 0) {
				pfr = explosion_med[i]->getActualFrame() + 1;
				if (explosion_med[i]->getActualFrame() > 24) {
					explosion_med[i]->setActivo(0);
					explosion_med[i]->selFrame(0);
				} else {
					explosion_med[i]->selFrame(pfr);
				}
			}
		}
	}
	
	// explosiones medianas1
	for (i=0; i < MAXEXP_MED; i++) {
		if (explosion_med1[i]->getTipoElemento() != EXP_TORRE) { // tipo nomal
			if (explosion_med1[i]->getActivo() == 1) {
				explosion_med1[i]->addY(2);
				explosion_med1[i]->dibujar(screen);
				if (ciclos % 2 == 0) {
					pfr = explosion_med1[i]->getActualFrame() + 1;
					if (explosion_med1[i]->getActualFrame() > 24) {
						explosion_med1[i]->setActivo(0);
						explosion_med1[i]->selFrame(0);
					} else {
						explosion_med1[i]->selFrame(pfr);
					}
				}
			}
		} else { // tipo torre
			if (explosion_med1[i]->getActivo() == 1) {
				explosion_med1[i]->dibujar(screen);
				//if (ciclos % 2 == 0) {
					pfr = explosion_med1[i]->getActualFrame() + 1;
					if (explosion_med1[i]->getActualFrame() > 25) {
						explosion_med1[i]->selFrame(26);
						if (explosion_med1[i]->fueraLimitesDePantalla()) {
							explosion_med1[i]->setActivo(0);
							explosion_med1[i]->selFrame(0);
							explosion_med1[i]->setTipoElemento(0);
						}
					} else {
						explosion_med1[i]->selFrame(pfr);
					}
				//}
			}
		}
	}
	
}


void Explosion::iniciar () {
	int i;
	for (i=0; i < MAXENE_GEN1; i++) {
		explosion_gav1[i]->setActivo(0);
		explosion_gav2[i]->setActivo(0);
		explosion_navepeq[i]->setActivo(0);
	}
	
	for (i=0; i < MAXENE_GEN2*2; i++) {
		explosion_navemed[i]->setActivo(0);
	}
	
	for (i=0; i < MAXENE_GEN3*2; i++) {
		explosion_navegr[i]->setActivo(0);
	}
	
	for (i=0; i < MAXDISP_GR; i++) {
		explosion_dispgr[i]->setActivo(0);
		explosion_dispgr_azul[i]->setActivo(0);
	}
	
	for (i=0; i < MAXENE_MARINOS; i++) {
		explosion_cangrebot[i]->setActivo(0);
		explosion_pulpo[i]->setActivo(0);
	}
	
	for (i=0; i < MAXENE_AUTOMARINO; i++) {
		explosion_lancha[i]->setActivo(0);
	}
	
	for (i=0; i < MAXENE_CONSTRUCCIONES; i++) {
		explosion_caseta[i]->setActivo(0);
	}
	
	for (i=0; i < MAXDISP_POMPA; i++) {
		explosion_pompagr[i]->setActivo(0);
		explosion_pompapeq[i]->setActivo(0);
	}
	
	for (i=0; i < MAXENE_CSIMPLE*2; i++) {
		explosion_coche[i]->setTipoElemento(0);
		explosion_coche[i]->setActivo(0);
	}
	
	for (i=0; i < MAXENE_EXPBARRERAS; i++) {
		explosion_barrera[i]->setActivo(0);
	}
	
	for (i=0; i < MAXEXP_MED; i++) {
		explosion_med[i]->setActivo(0);
		explosion_med1[i]->setTipoElemento(0);
		explosion_med1[i]->setActivo(0);
	}
	
	for (i=0; i < MAXENE_TANQUE; i++) {
		explosion_tanque[i]->setActivo(0);
	}
	
	for (i=0; i < MAXEXP_GR; i++) {
		explosion_gr0[i]->setActivo(0);
	}
	
	for (i=0; i < MAXENE_YATE; i++) {
		explosion_yate[i]->setActivo(0);
	}
	
	ciclos = 0; 
	explosionJefe.x = 0;
	explosionJefe.y = 0;
	explosionJefe.activo = false;
	explosionJefe.swExplotar = false;
	
}

void Explosion::unLoad() {
	int i;

	for (i=0; i < MAXENE_GEN1; i++) {
		explosion_navepeq[i]->unLoad();
		explosion_gav1[i]->unLoad();
		explosion_gav2[i]->unLoad();
	}
	
	for (i=0; i < MAXENE_GEN2*2; i++) {
		explosion_navemed[i]->unLoad();
	}
	
	for (i=0; i < MAXENE_GEN3*2; i++) {
		explosion_navegr[i]->unLoad();
	}
	
	for (i=0; i < MAXENE_EXPBARRERAS; i++) {
		explosion_barrera[i]->unLoad();
	}
	
	for (i=0; i < MAXDISP_GR; i++) {
		explosion_dispgr[i]->unLoad();
		explosion_dispgr_azul[i]->unLoad();
	}
	
	for (i=0; i < MAXENE_MARINOS; i++) {
		explosion_cangrebot[i]->unLoad();
		explosion_pulpo[i]->unLoad();
	}
	
	for (i=0; i < MAXENE_AUTOMARINO; i++) {
		explosion_lancha[i]->unLoad();
	}
	
	for (i=0; i < MAXENE_CONSTRUCCIONES; i++) {
		 explosion_caseta[i]->unLoad();
	}
	
	for (i=0; i < MAXDISP_POMPA; i++) {
		 explosion_pompagr[i]->unLoad();
		 explosion_pompapeq[i]->unLoad();
	}
	
	for (i=0; i < MAXENE_CSIMPLE*2; i++) {
		explosion_coche[i]->unLoad();
	}
	 
	for (i=0; i < MAXEXP_MED; i++) {
		explosion_med[i]->unLoad();
		explosion_med1[i]->unLoad();
	}
	
	for (i=0; i < MAXENE_TANQUE; i++) {
		explosion_tanque[i]->unLoad();
	}
	
	for (i=0; i < MAXEXP_GR; i++) {
		explosion_gr0[i]->unLoad();
	}
	
	for (i=0; i < MAXENE_YATE; i++) {
		explosion_yate[i]->unLoad();
	}
	
	
}
