/*
 * Tirititran es un juego de naves en 2D ambientado en Cádiz
 * Copyright (C) 2004  Javier Pérez Pacheco
 *
 * Este juego tienen licencia Creative Commons y se permite
 * su modificacion y utilizacion libremente siempre y cuando se
 * cite al autor original y se comparta con la misma licencia.
 * No se permite su uso comercial.
 * 
 * Para mas informacion visite la web:
 * http://creativecommons.org/licenses/by-nc-sa/2.0/es/
 *
 * PROGRAMADOR
 * Javier Pérez Pacheco
 * Cadiz (Spain)
 * javi.pacheco@terra.es
 *
 * GRAFISMO Y 3D
 * Jesus Carrasco
 * Cadiz (Spain)
 * carrasco.carrasco@gmail.com
 *
 * MUSICA Y GRAFISMO
 * Shano Lores
 * Cadiz (Spain)
 * shano@mail.ono.es
 *
 */
 
 #include "opciones.h"

 
/*****************************
**
** CLASE OPCIONES
**
******************************/

Opciones::Opciones(Pantalla *pant) {
	verAnimacion = false;
	char tmpch[127];
	char tmpimg[127];
	p = pant;
	errorClave = 0;
	botonJoystickPulsado = -1;
	tiempoTextoPantalla = -1;
	
	balancearModelo = false;
	transModelo = 0.4;
	
	sprintf (tmpch, "%s/opciones.tim", DATA_DIR);
	
	Frame frFondo, frTeclado, frPuntuaciones, frJoystick, frClave, frCreditos;
	opcion = 0;
	opcion_opciones = 0;
	nivel = 0;
	strcpy(claveFase,"");
	strcpy(tmpClaveFase,"");
	tamClaveFase=0;
	 
	pantalla_h = 480;
	pantalla_w = 640;
	sizeFont = 25;
	sizeFontSel = 27;
	espaciado = 26;
	int i;
	
	// frames del joystrick
	
	Frame frJoy_conectado;
	joy_conectado = new Elemento();	 
	frJoy_conectado.loadFromRAR	(tmpch, "opc_joy_conect.timp");
	joy_conectado->addFrame(frJoy_conectado);
	joy_conectado->setAlign(ALIGN_CENTER);
	joy_conectado->setVAlign(VALIGN_CENTER);
	joy_conectado->setX(482);
	joy_conectado->setY(215);
	
	Frame frJoy_noconectado;
	joy_noconectado = new Elemento();	 
	frJoy_noconectado.loadFromRAR (tmpch, "opc_joy_noconect.timp");
	joy_noconectado->addFrame(frJoy_noconectado);
	joy_noconectado->setAlign(ALIGN_CENTER);
	joy_noconectado->setVAlign(VALIGN_CENTER);
	joy_noconectado->setX(482);
	joy_noconectado->setY(215);
	
	Frame frJoy_disparo;
	joy_disparo = new Elemento();	 
	frJoy_disparo.loadFromRAR (tmpch, "opc_disparo.timp");
	joy_disparo->addFrame(frJoy_disparo);
	joy_disparo->setAlign(ALIGN_CENTER);
	joy_disparo->setVAlign(VALIGN_CENTER);
	joy_disparo->setX(482);
	joy_disparo->setY(405);
	
	Frame frJoy_usar_poder;
	joy_usar_poder = new Elemento();	 
	frJoy_usar_poder.loadFromRAR (tmpch, "opc_usar_poder.timp");
	joy_usar_poder->addFrame(frJoy_usar_poder);
	joy_usar_poder->setAlign(ALIGN_CENTER);
	joy_usar_poder->setVAlign(VALIGN_CENTER);
	joy_usar_poder->setX(482);
	joy_usar_poder->setY(405);
	
	Frame frJoy_sel_poder;
	joy_sel_poder = new Elemento();	 
	frJoy_sel_poder.loadFromRAR (tmpch, "opc_sel_poder.timp");
	joy_sel_poder->addFrame(frJoy_sel_poder);
	joy_sel_poder->setAlign(ALIGN_CENTER);
	joy_sel_poder->setVAlign(VALIGN_CENTER);
	joy_sel_poder->setX(482);
	joy_sel_poder->setY(405);
	
	Frame frJoy_intercom;
	joy_intercom = new Elemento();	 
	frJoy_intercom.loadFromRAR (tmpch, "opc_intercom.timp");
	joy_intercom->addFrame(frJoy_intercom);
	joy_intercom->setAlign(ALIGN_CENTER);
	joy_intercom->setVAlign(VALIGN_CENTER);
	joy_intercom->setX(482);
	joy_intercom->setY(405);
	
	
	// fondos y cajas
	
	fondo = new Elemento();	 
	frFondo.loadFromRAR	(tmpch, "fondo.timj");
	fondo->addFrame(frFondo);
	fondo->setX(0);
	fondo->setY(0);
	
	Frame frCaja;
	caja = new Elemento();	 
	frCaja.loadFromRAR (tmpch, "caja.timp");
	caja->addFrame(frCaja);
	caja->setX(10);
	caja->setY(pantalla_h);
	
	Frame frModelo;
	modelo = new Elemento();	 
	frModelo.loadFromRAR(tmpch, "tirititran.timp");
	modelo->addFrame(frModelo);
	modelo->setAlign(ALIGN_RIGHT);
	modelo->setX(640);
	modelo->setY(pantalla_h);
	 
	teclado = new Elemento();
	frTeclado.loadFromRAR(tmpch, "teclado.timp");
	teclado->addFrame(frTeclado);
	teclado->setX(-teclado->getAncho());
	teclado->setY(-teclado->getAlto());
	
	joystick = new Elemento();
	frJoystick.loadFromRAR(tmpch, "joystick.timp");
	joystick->addFrame(frJoystick);
	joystick->setX(-joystick->getAncho());
	joystick->setY(-joystick->getAlto());
	
	cruz = new Elemento();
	Frame frCruz;
	frCruz.loadFromRAR(tmpch, "cruz.timp");
	cruz->addFrame(frCruz);
	cruz->setX(465);
	cruz->setY(285);
	
	puntuaciones = new Elemento();
	frPuntuaciones.loadFromRAR(tmpch, "puntuaciones.timp");
	puntuaciones->addFrame(frPuntuaciones);
	puntuaciones->setAlign(ALIGN_CENTER);
	puntuaciones->setX(p->pantalla_w/2);
	puntuaciones->setY(p->pantalla_h);
	
	creditos = new Elemento();
	frCreditos.loadFromRAR(tmpch, "creditos.timp");
	creditos->addFrame(frCreditos);
	creditos->setAlign(ALIGN_CENTER);
	creditos->setX(p->pantalla_w/2);
	creditos->setY(p->pantalla_h);
	
	Frame frOpciones;
	
	opciones = new Elemento();
	frOpciones.loadFromRAR(tmpch, "opciones.timp");
	opciones->addFrame(frOpciones);
	opciones->setAlign(ALIGN_CENTER);
	opciones->setX(p->pantalla_w/2);
	opciones->setY(p->pantalla_h);
	
	clave = new Elemento();
	frClave.loadFromRAR(tmpch, "clave.timp");
	clave->addFrame(frClave);
	clave->setAlign(ALIGN_CENTER);
	clave->setX(p->pantalla_w/2);
	clave->setY(p->pantalla_h);

	sprintf (nOpciones[0], "jugar");
	sprintf (nOpciones[1], "opciones");
	sprintf (nOpciones[2], "controles");
	sprintf (nOpciones[3], "puntuaciones");
	sprintf (nOpciones[4], "claves");
	sprintf (nOpciones[5], "comojugar");
	sprintf (nOpciones[6], "creditos");
	sprintf (nOpciones[7], "salir");

	SDL_Surface *surface;
	Frame fr;
	for (i=0; i<NOPCIONES; i++) {
		ele_nOpciones[i] = new Elemento(2);
		sprintf (tmpimg, "%s_off.timp", nOpciones[i]);
		fr.loadFromRAR	(tmpch, tmpimg);
		//surface = crearTextoConSombra(nOpciones[i], 0); // 0 para texto normal
		//fr.loadSurface(surface);
		ele_nOpciones[i]->addFrame(fr);
		sprintf (tmpimg, "%s_on.timp", nOpciones[i]);
		fr.loadFromRAR	(tmpch, tmpimg);
		//surface = crearTextoConSombra(nOpciones[i], 1); // 1 para texto seleccionado
		//fr.loadSurface(surface);
		ele_nOpciones[i]->addFrame(fr);
		ele_nOpciones[i]->setAlign(ALIGN_CENTER);
		ele_nOpciones[i]->setVAlign(VALIGN_CENTER);
		if (i%2==0)
			ele_nOpciones[i]->setX(-ele_nOpciones[i]->getAncho()-250);
		else
			ele_nOpciones[i]->setX(p->pantalla_w+250);
		ele_nOpciones[i]->setY(240+(espaciado*i));
	}
	
	posInicialOpciones();
	
	sprintf (nOpciones_Opciones[0], "vol_musica");
	sprintf (nOpciones_Opciones[1], "vol_sonido");
	sprintf (nOpciones_Opciones[2], "hardware");
	sprintf (nOpciones_Opciones[3], "vel_juego");
	sprintf (nOpciones_Opciones[4], "fullscreen");
	sprintf (nOpciones_Opciones[5], "color");
	sprintf (nOpciones_Opciones[6], "guardar");
	sprintf (nOpciones_Opciones[7], "volver_menu");
	
	for (i=0; i<NOPCIONES_OPCIONES; i++) {
		ele_nOpciones_Opciones[i] = new Elemento(2);
		sprintf (tmpimg, "opc_%s_off.timp", nOpciones_Opciones[i]);
		fr.loadFromRAR	(tmpch, tmpimg);
		//surface = crearTextoConSombra(nOpciones_Opciones[i], 0); // 0 para texto normal
		//fr.loadSurface(surface);
		ele_nOpciones_Opciones[i]->addFrame(fr);
		sprintf (tmpimg, "opc_%s_on.timp", nOpciones_Opciones[i]);
		fr.loadFromRAR	(tmpch, tmpimg);
		//surface = crearTextoConSombra(nOpciones_Opciones[i], 1); // 1 para texto seleccionado
		//fr.loadSurface(surface);
		ele_nOpciones_Opciones[i]->addFrame(fr);
		ele_nOpciones_Opciones[i]->setVAlign(VALIGN_CENTER);
		ele_nOpciones_Opciones[i]->setX(-ele_nOpciones_Opciones[i]->getAncho()-250);
		ele_nOpciones_Opciones[i]->setY(180+(34*i));
	}
	
	sprintf (nOpcionesMusica[0], "nulo");
	sprintf (nOpcionesMusica[1], "bajo");
	sprintf (nOpcionesMusica[2], "medio");
	sprintf (nOpcionesMusica[3], "alto");
	
	for (i=0; i<4; i++) {
		ele_nOpcionesMusica[i] = new Elemento(2);
		sprintf (tmpimg, "opc_%s_off.timp", nOpcionesMusica[i]);
		fr.loadFromRAR	(tmpch, tmpimg);
		//surface = crearTextoConSombra(nOpcionesMusica[i], 0); // 0 para texto normal
		//fr.loadSurface(surface);
		ele_nOpcionesMusica[i]->addFrame(fr);
		sprintf (tmpimg, "opc_%s_on.timp", nOpcionesMusica[i]);
		fr.loadFromRAR	(tmpch, tmpimg);
		//surface = crearTextoConSombra(nOpcionesMusica[i], 1); // 1 para texto seleccionado
		//fr.loadSurface(surface);
		ele_nOpcionesMusica[i]->addFrame(fr);
		ele_nOpcionesMusica[i]->setVAlign(VALIGN_CENTER);
		ele_nOpcionesMusica[i]->setAlign(ALIGN_RIGHT);
		ele_nOpcionesMusica[i]->setX(p->pantalla_w+200);
		ele_nOpcionesMusica[i]->setY(ele_nOpciones_Opciones[0]->getY()); // mismo en Y que el elemento de musica de la opcion
	}
	
	sprintf (nOpcionesSonido[0], "nulo");
	sprintf (nOpcionesSonido[1], "bajo");
	sprintf (nOpcionesSonido[2], "medio");
	sprintf (nOpcionesSonido[3], "alto");
	
	for (i=0; i<4; i++) {
		ele_nOpcionesSonido[i] = new Elemento(2);
		sprintf (tmpimg, "opc_%s_off.timp", nOpcionesSonido[i]);
		fr.loadFromRAR	(tmpch, tmpimg);
		//surface = crearTextoConSombra(nOpcionesSonido[i], 0); // 0 para texto normal
		//fr.loadSurface(surface);
		ele_nOpcionesSonido[i]->addFrame(fr);
		sprintf (tmpimg, "opc_%s_on.timp", nOpcionesSonido[i]);
		fr.loadFromRAR	(tmpch, tmpimg);
		//surface = crearTextoConSombra(nOpcionesSonido[i], 1); // 1 para texto seleccionado
		//fr.loadSurface(surface);
		ele_nOpcionesSonido[i]->addFrame(fr);
		ele_nOpcionesSonido[i]->setVAlign(VALIGN_CENTER);
		ele_nOpcionesSonido[i]->setAlign(ALIGN_RIGHT);
		ele_nOpcionesSonido[i]->setX(p->pantalla_w+200);
		ele_nOpcionesSonido[i]->setY(ele_nOpciones_Opciones[1]->getY()); // mismo en Y que el elemento de sonido de la opcion
	}
	
	sprintf (nOpcionesHardware[0], "no");
	sprintf (nOpcionesHardware[1], "si");
	
	for (i=0; i<2; i++) {
		ele_nOpcionesHardware[i] = new Elemento(2);
		sprintf (tmpimg, "opc_%s_off.timp", nOpcionesHardware[i]);
		fr.loadFromRAR	(tmpch, tmpimg);
		//surface = crearTextoConSombra(nOpcionesHardware[i], 0); // 0 para texto normal
		//fr.loadSurface(surface);
		ele_nOpcionesHardware[i]->addFrame(fr);
		sprintf (tmpimg, "opc_%s_on.timp", nOpcionesHardware[i]);
		fr.loadFromRAR	(tmpch, tmpimg);
		//surface = crearTextoConSombra(nOpcionesHardware[i], 1); // 1 para texto seleccionado
		//fr.loadSurface(surface);
		ele_nOpcionesHardware[i]->addFrame(fr);
		ele_nOpcionesHardware[i]->setVAlign(VALIGN_CENTER);
		ele_nOpcionesHardware[i]->setAlign(ALIGN_RIGHT);
		ele_nOpcionesHardware[i]->setX(p->pantalla_w+200);
		ele_nOpcionesHardware[i]->setY(ele_nOpciones_Opciones[2]->getY()); // mismo en Y que el elemento de sonido de la opcion
	}
	
	sprintf (nOpcionesVelocidadJuego[0], "lento");
	sprintf (nOpcionesVelocidadJuego[1], "normal");
	sprintf (nOpcionesVelocidadJuego[2], "rapido");
	
	for (i=0; i<3; i++) {
		ele_nOpcionesVelocidadJuego[i] = new Elemento(2);
		sprintf (tmpimg, "opc_%s_off.timp", nOpcionesVelocidadJuego[i]);
		fr.loadFromRAR	(tmpch, tmpimg);
		//surface = crearTextoConSombra(nOpcionesVelocidadJuego[i], 0); // 0 para texto normal
		//fr.loadSurface(surface);
		ele_nOpcionesVelocidadJuego[i]->addFrame(fr);
		sprintf (tmpimg, "opc_%s_on.timp", nOpcionesVelocidadJuego[i]);
		fr.loadFromRAR	(tmpch, tmpimg);
		//surface = crearTextoConSombra(nOpcionesVelocidadJuego[i], 1); // 1 para texto seleccionado
		//fr.loadSurface(surface);
		ele_nOpcionesVelocidadJuego[i]->addFrame(fr);
		ele_nOpcionesVelocidadJuego[i]->setVAlign(VALIGN_CENTER);
		ele_nOpcionesVelocidadJuego[i]->setAlign(ALIGN_RIGHT);
		ele_nOpcionesVelocidadJuego[i]->setX(p->pantalla_w+200);
		ele_nOpcionesVelocidadJuego[i]->setY(ele_nOpciones_Opciones[3]->getY()); // mismo en Y que el elemento de sonido de la opcion
	}
	
	sprintf (nOpcionesFullScreen[0], "no");
	sprintf (nOpcionesFullScreen[1], "si");
	
	for (i=0; i<2; i++) {
		ele_nOpcionesFullScreen[i] = new Elemento(2);
		sprintf (tmpimg, "opc_%s_off.timp", nOpcionesFullScreen[i]);
		fr.loadFromRAR	(tmpch, tmpimg);
		//surface = crearTextoConSombra(nOpcionesFullScreen[i], 0); // 0 para texto normal
		//fr.loadSurface(surface);
		ele_nOpcionesFullScreen[i]->addFrame(fr);
		sprintf (tmpimg, "opc_%s_on.timp", nOpcionesFullScreen[i]);
		fr.loadFromRAR	(tmpch, tmpimg);
		//surface = crearTextoConSombra(nOpcionesFullScreen[i], 1); // 1 para texto seleccionado
		//fr.loadSurface(surface);
		ele_nOpcionesFullScreen[i]->addFrame(fr);
		ele_nOpcionesFullScreen[i]->setVAlign(VALIGN_CENTER);
		ele_nOpcionesFullScreen[i]->setAlign(ALIGN_RIGHT);
		ele_nOpcionesFullScreen[i]->setX(p->pantalla_w+200);
		ele_nOpcionesFullScreen[i]->setY(ele_nOpciones_Opciones[4]->getY()); // mismo en Y que el elemento de sonido de la opcion
	}
	
	sprintf (nOpcionesBpp[0], "16bpp");
	sprintf (nOpcionesBpp[1], "24bpp");
	sprintf (nOpcionesBpp[2], "32bpp");
	
	for (i=0; i<3; i++) {
		ele_nOpcionesBpp[i] = new Elemento(2);
		sprintf (tmpimg, "opc_%s_off.timp", nOpcionesBpp[i]);
		fr.loadFromRAR	(tmpch, tmpimg);
		//surface = crearTextoConSombra(nOpcionesBpp[i], 0); // 0 para texto normal
		//fr.loadSurface(surface);
		ele_nOpcionesBpp[i]->addFrame(fr);
		sprintf (tmpimg, "opc_%s_on.timp", nOpcionesBpp[i]);
		fr.loadFromRAR	(tmpch, tmpimg);
		//surface = crearTextoConSombra(nOpcionesBpp[i], 1); // 1 para texto seleccionado
		//fr.loadSurface(surface);
		ele_nOpcionesBpp[i]->addFrame(fr);
		ele_nOpcionesBpp[i]->setVAlign(VALIGN_CENTER);
		ele_nOpcionesBpp[i]->setAlign(ALIGN_RIGHT);
		ele_nOpcionesBpp[i]->setX(p->pantalla_w+200);
		ele_nOpcionesBpp[i]->setY(ele_nOpciones_Opciones[5]->getY()); // mismo en Y que el elemento de sonido de la opcion
	}
	
	cargarValoresConfiguracion(p);
	
	// puntuaciones
	
	p->getConfiguracion()->ordenarPuntuaciones();
	for (i=0; i<5; i++) {
		ele_PuntNombres[i] = new Elemento();
		ele_PuntPuntos[i] = new Elemento();
		surface = crearTextoConSombra(p->getConfiguracion()->getPuntuacionNombre(i), 0); // 0 para texto normal
		fr.loadSurface(surface);
		ele_PuntNombres[i]->addFrame(fr);
		ele_PuntNombres[i]->setVAlign(VALIGN_CENTER);
		ele_PuntNombres[i]->setX(-ele_PuntNombres[i]->getAncho()-250);
		ele_PuntNombres[i]->setY(215+(40*i));
		sprintf (tmpch, "%d", p->getConfiguracion()->getPuntuacionPuntos(i)); 
		surface = crearTextoConSombra(tmpch, 0); // 0 para texto normal
		fr.loadSurface(surface);
		ele_PuntPuntos[i]->addFrame(fr);
		ele_PuntPuntos[i]->setVAlign(VALIGN_CENTER);
		ele_PuntPuntos[i]->setX(-ele_PuntPuntos[i]->getAncho());
		ele_PuntPuntos[i]->setY(215+(40*i));
	}
	
	cargarPuntuaciones();
	
	
 }

void Opciones::posInicialOpciones() {
	int i;
	for (i=0; i<NOPCIONES; i++) {
		if (i%2==0)
			ele_nOpciones[i]->setX(-ele_nOpciones[i]->getAncho()-250);
		else
			ele_nOpciones[i]->setX(p->pantalla_w+250);
		ele_nOpciones[i]->setY(240+(espaciado*i));
		ele_nOpciones[i]->setPorPosicionX(185);
	}
	
	modelo->setX(pantalla_w+modelo->getAncho());
	modelo->setY(pantalla_h);
	modelo->setPorPosicion(640, 85);
	
	caja->setY(pantalla_h);
	caja->setPorPosicionY(100);
}

void Opciones::posFinalOpciones() { 
	int i;
	for (i=0; i<NOPCIONES; i++) {
		ele_nOpciones[i]->setPorPosicionY(p->pantalla_h+(50*(i+1)));
	}
	caja->setPorPosicionY(pantalla_h);
	//modelo->setPorPosicion(pantalla_w+modelo->getAncho()+100, -200);
	balancearModelo = false;
	transModelo = abs(transModelo);
	modelo->setPorPosicionY(-modelo->getAlto()-100);
}
	
void Opciones::posInicialOpciones_Opciones() {
	int i;
	for (i=0; i<NOPCIONES_OPCIONES; i++) {
		ele_nOpciones_Opciones[i]->setX(-ele_nOpciones_Opciones[i]->getAncho()-250);
		ele_nOpciones_Opciones[i]->setPorPosicionX(85);
	}
	for (i=0; i<4; i++) {
		ele_nOpcionesMusica[i]->setX(p->screen_w+250);
		ele_nOpcionesMusica[i]->setPorPosicionX(p->pantalla_w-85);
	}
	for (i=0; i<4; i++) {
		ele_nOpcionesSonido[i]->setX(p->screen_w+250);
		ele_nOpcionesSonido[i]->setPorPosicionX(p->pantalla_w-85);
	}
	for (i=0; i<2; i++) {
		ele_nOpcionesHardware[i]->setX(p->screen_w+250);
		ele_nOpcionesHardware[i]->setPorPosicionX(p->pantalla_w-85);
	}
	for (i=0; i<3; i++) {
		ele_nOpcionesVelocidadJuego[i]->setX(p->screen_w+250);
		ele_nOpcionesVelocidadJuego[i]->setPorPosicionX(p->pantalla_w-85);
	}
	for (i=0; i<2; i++) {
		ele_nOpcionesFullScreen[i]->setX(p->screen_w+250);
		ele_nOpcionesFullScreen[i]->setPorPosicionX(p->pantalla_w-85);
	}
	for (i=0; i<3; i++) {
		ele_nOpcionesBpp[i]->setX(p->screen_w+250);
		ele_nOpcionesBpp[i]->setPorPosicionX(p->pantalla_w-85);
	}
	opciones->setY(p->pantalla_h);
	opciones->setPorPosicionY(110);
}

void Opciones::posFinalOpciones_Opciones() { 
	int i;
	for (i=0; i<NOPCIONES_OPCIONES; i++) {
		ele_nOpciones_Opciones[i]->setPorPosicionX(-ele_nOpciones_Opciones[i]->getAncho()-250);
	}
	for (i=0; i<4; i++) {
		ele_nOpcionesMusica[i]->setPorPosicionX(p->pantalla_w+200);
	}
	for (i=0; i<4; i++) {
		ele_nOpcionesSonido[i]->setPorPosicionX(p->pantalla_w+200);
	}
	for (i=0; i<2; i++) {
		ele_nOpcionesHardware[i]->setPorPosicionX(p->pantalla_w+200);
	}
	for (i=0; i<3; i++) {
		ele_nOpcionesVelocidadJuego[i]->setPorPosicionX(p->pantalla_w+200);
	}
	for (i=0; i<2; i++) {
		ele_nOpcionesFullScreen[i]->setPorPosicionX(p->pantalla_w+200);
	}
	for (i=0; i<3; i++) {
		ele_nOpcionesBpp[i]->setPorPosicionX(p->pantalla_w+200);
	}
	opciones->setPorPosicionY(p->pantalla_h);
}

void Opciones::posInicialControles() {
	teclado->setX(-teclado->getAlto());
	teclado->setY(120);
	teclado->setPorPosicionX(10);
	
	joystick->setX(p->pantalla_w);
	joystick->setY(120);
	joystick->setPorPosicionX(325);
}

void Opciones::posFinalControles() {
	teclado->setPorPosicionX(-teclado->getAlto());
	joystick->setPorPosicionX(p->pantalla_w);
}


void Opciones::posInicialPuntuaciones() {
	int i;
	for (i=0; i<5; i++) {
		ele_PuntNombres[i]->setX(-ele_PuntNombres[i]->getAncho()-250);
		ele_PuntNombres[i]->setPorPosicionX(150);
		ele_PuntPuntos[i]->setX(p->pantalla_w+250);
		ele_PuntPuntos[i]->setPorPosicionX(390);
	}
	puntuaciones->setY(p->pantalla_h);
	puntuaciones->setPorPosicionY(110);
}

void Opciones::posFinalPuntuaciones() {
	int i;
	for (i=0; i<5; i++) {
		ele_PuntNombres[i]->setPorPosicionX(-ele_PuntNombres[i]->getAncho()-250);
		ele_PuntPuntos[i]->setPorPosicionX(p->pantalla_w+250);
	}
	puntuaciones->setPorPosicionY(p->pantalla_h);
}

void Opciones::posInicialCreditos() {
	creditos->setY(p->pantalla_h);
	creditos->setPorPosicionY(110);
}

void Opciones::posFinalCreditos() {
	creditos->setPorPosicionY(p->pantalla_h);
}

void Opciones::posInicialClave() {
	errorClave = 0;
	clave->setY(p->pantalla_h);
	clave->setPorPosicionY(110);
}

void Opciones::posFinalClave() {
	clave->setPorPosicionY(p->pantalla_h);
}

SDL_Surface* Opciones::crearTextoConSombra(char texto[127], int tipo) { 
	SDL_Surface *surface_sombra, *surface;
	if (tipo==0) {
		surface_sombra = p->fuente->escribirTexto(0, sizeFont, texto, 0, 0, 0, 0, 0, 30);
		surface = p->fuente->escribirTexto(0, sizeFont, texto, 255, 255, 255, 0, 0, 0);
	} else {
		surface_sombra = p->fuente->escribirTexto(0, sizeFontSel, texto, 0, 0, 0, 0, 0, 30);
		surface = p->fuente->escribirTexto(0, sizeFontSel, texto, 255, 230, 23, 0, 0, 0);
	}
	SDL_Surface* surface_texto = SDL_CreateRGBSurface (p->screen->flags,
									surface_sombra->w+5, surface_sombra->h+5, p->screen->format->BitsPerPixel,
									p->screen->format->Rmask, p->screen->format->Gmask,
									p->screen->format->Bmask,
									0);

	int colorkey = SDL_MapRGB(surface_texto->format, 0, 0, 80);
	SDL_FillRect(surface_texto, NULL, colorkey);
	SDL_SetColorKey(surface_texto, SDL_SRCCOLORKEY, colorkey);

	SDL_Rect dest;
	dest.x = 5;
	dest.y = 5;
	dest.h = surface->h+5;
	dest.w = surface->w+5;
	SDL_BlitSurface(surface_sombra, NULL, surface_texto, &dest);
	SDL_BlitSurface (surface, NULL, surface_texto, NULL);
	SDL_FreeSurface (surface_sombra);
	SDL_FreeSurface (surface);
	return surface_texto;
}

void Opciones::cargarValoresConfiguracion(Pantalla *p) {
	opcMusica = p->getConfiguracion()->getOpcion("vol_musica");
	opcSonido = p->getConfiguracion()->getOpcion("vol_sonido");
	opcHardware = p->getConfiguracion()->getOpcion("ace_hardware");
	opcVelocidadJuego = p->getConfiguracion()->getOpcion("vel_juego");
	opcFullScreen = p->getConfiguracion()->getOpcion("fullscreen");
	opcBpp = p->getConfiguracion()->getOpcion("bpp");
}

void Opciones::cargarPuntuaciones() {
	char tmpch[127];
	int i;
	SDL_Surface *surface;
	p->getConfiguracion()->ordenarPuntuaciones();
	for (i=0; i<5; i++) {
		surface = crearTextoConSombra(p->getConfiguracion()->getPuntuacionNombre(i), 1); // 0 para texto normal
		ele_PuntNombres[i]->sprite[0].img = surface;
		sprintf (tmpch, "%d", p->getConfiguracion()->getPuntuacionPuntos(i)); 
		surface = crearTextoConSombra(tmpch, 0); // 0 para texto normal
		ele_PuntPuntos[i]->sprite[0].img = surface;
	}
}

 int Opciones::escena() {
	 
	if (verAnimacion) {
		int r = anim->DrawAnimation();
		SDL_Flip (p->screen);
		if (r==1) {
			verAnimacion = false;
			p->sonido->empezarMusica(MUS_OPCIONES);
		}
		return 0;
	}
	 
	SDL_Rect clip_completo;
	SDL_Event event;
	 
	clip_completo.x = 0;
	clip_completo.y = 0;
	clip_completo.h = 600;
	clip_completo.w = 800;
	 
	SDL_SetClipRect (p->screen, &clip_completo);
	dibujar();
	SDL_Flip (p->screen);
	
 
	// Comprobando teclas para opciones segun nivel
	switch (nivel) {
	case 0:
		while (SDL_PollEvent(&event)) {
			// Cerrar la ventana
			if (event.type == SDL_QUIT) { return -1; } 
			// Pulsando una tecla
			if ( (event.type == SDL_KEYDOWN) || (event.type == SDL_JOYAXISMOTION) || (event.type == SDL_JOYBUTTONDOWN)  ) {
				// Pulsar ESCAPE se sale
				if (event.key.keysym.sym == SDLK_ESCAPE) { 
					return -1;
				} else if ( (event.key.keysym.sym == SDLK_UP) || ( (event.jaxis.value < -3200) && event.jaxis.axis == 1 && (event.type == SDL_JOYAXISMOTION) ) ) {// && event.jaxis.axis == 1 
					subirOpcion();
					p->sonido->playSonido(SND_CLICK);
				} else if ( (event.key.keysym.sym == SDLK_DOWN) || ( (event.jaxis.value > 3200) && event.jaxis.axis == 1 && (event.type == SDL_JOYAXISMOTION) ) ) { // && event.jaxis.axis == 1 
					bajarOpcion();
					p->sonido->playSonido(SND_CLICK);
				} else if ( (event.key.keysym.sym == SDLK_RETURN) || ( ( event.jbutton.button == 0 ) && (event.type == SDL_JOYBUTTONDOWN)  ) ) {
					if ( getOpcion() == 0) { // empezar a jugar
						p->sonido->terminarMusica ();
						p->initSpriteNivel(1);
						Mix_HaltChannel(-1);
						//if ( p->getCiclos() > 0 ) {
							p->iniciarPantalla();
							p->iniciarJuego();
							p->getJuego()->establecerContinue();
							p->getJuego()->setZonaSobrepasada(0);
						//} else {
							p->empezarMusicaFase();
							//p->entradaJugador();
						//}
						return JUEGO_ESCENA;
					} else if ( getOpcion() == 1) { // pasar a nivel de opciones
						posInicialOpciones_Opciones();
						posFinalOpciones();
						cargarValoresConfiguracion(p);
						nivel = 1; 
					} else if ( getOpcion() == 2) { // pasar a nivel de teclado
						posFinalOpciones();
						posInicialControles();
						nivel = 2; 
					} else if ( getOpcion() == 3) { // pasar a nivel de puntuaciones
						cargarPuntuaciones();
						posInicialPuntuaciones();
						posFinalOpciones();
						nivel = 3; 
					} else if ( getOpcion() == 4) { // pasar a nivel de clave
						posInicialClave();
						posFinalOpciones();
						nivel = 4; 
					} else if ( getOpcion() == 5) { // como jugar
						p->sonido->terminarMusica ();
						p->initSpriteNivel(0);
						Mix_HaltChannel(-1);
						//if ( p->getCiclos() > 0 ) {
							p->iniciarPantalla();
							p->iniciarJuego();
							p->getJuego()->establecerContinue();
							p->getJuego()->setZonaSobrepasada(0);
						//} else {
							p->empezarMusicaFase();
							//p->entradaJugador();
						//}
						return JUEGO_COMOJUGAR;
					} else if ( getOpcion() == 6) { // pasar a nivel de creditos
						posInicialCreditos();
						posFinalOpciones();
						nivel = 6; 
					} else if ( getOpcion() == 7) { // salir
						return -1;
					}
				}
				SDL_SetClipRect (p->screen, &clip_completo);
				dibujar();
				SDL_Flip (p->screen);
			}
		}
	break;
	case 1:
		while (SDL_PollEvent(&event)) {
			// Cerrar la ventana
			if (event.type == SDL_QUIT) { return -1; } 
			// Pulsando una tecla
			if ( (event.type == SDL_KEYDOWN) || (event.type == SDL_JOYAXISMOTION) || (event.type == SDL_JOYBUTTONDOWN) ) {
				// Pulsar ESCAPE se sale
				if (event.key.keysym.sym == SDLK_ESCAPE) {
					posInicialOpciones();
					posFinalOpciones_Opciones();
					nivel = 0;
				} else if ( (event.key.keysym.sym == SDLK_UP) || ( event.jaxis.value < -3200 && event.jaxis.axis == 1 && event.type == SDL_JOYAXISMOTION ) ) {
					subirOpcion_Opcion();
					p->sonido->playSonido(SND_CLICK);
				} else if ( (event.key.keysym.sym == SDLK_DOWN) || (event.jaxis.value > 3200 && event.jaxis.axis == 1 && event.type == SDL_JOYAXISMOTION ) ) {
					bajarOpcion_Opcion();
					p->sonido->playSonido(SND_CLICK);
				} else if ( (event.key.keysym.sym == SDLK_LEFT) || ( event.jaxis.value < -3200 && event.jaxis.axis == 0 && event.type == SDL_JOYAXISMOTION ) )  {
					switch (getOpcion_Opcion()) {
						case 0:
							subirOpcionMusica();
						break;
						case 1:
							subirOpcionSonido();
						break;
						case 2:
							subirOpcionHardware();
						break;
						case 3:
							subirOpcionVelocidadJuego();
						break;
						case 4:
							subirOpcionFullScreen();
						break;
						case 5:
							subirOpcionBpp();
						break;
					}
					p->sonido->playSonido(SND_CLICK);
				} else if ( (event.key.keysym.sym == SDLK_RIGHT) || (event.jaxis.value > 3200 && event.jaxis.axis == 0 && event.type == SDL_JOYAXISMOTION ) ) {
					switch (getOpcion_Opcion()) {
						case 0:
							bajarOpcionMusica();
						break;
						case 1:
							bajarOpcionSonido();
						break;
						case 2:
							bajarOpcionHardware();
						break;
						case 3:
							bajarOpcionVelocidadJuego();
						break;
						case 4:
							bajarOpcionFullScreen();
						break;
						case 5:
							bajarOpcionBpp();
						break;
					}
					p->sonido->playSonido(SND_CLICK);
				} else if ( (event.key.keysym.sym == SDLK_RETURN) || ( (event.jbutton.button == 0) && (event.type == SDL_JOYBUTTONDOWN) ) ) {
					if ( getOpcion_Opcion() == 6) {
						p->getConfiguracion()->actualizarOpcion("vol_musica", opcMusica);
						p->getConfiguracion()->actualizarOpcion("vol_sonido", opcSonido);
						p->getConfiguracion()->actualizarOpcion("ace_hardware", opcHardware);
						p->getConfiguracion()->actualizarOpcion("vel_juego", opcVelocidadJuego);
						p->getConfiguracion()->actualizarOpcion("fullscreen", opcFullScreen);
						p->getConfiguracion()->actualizarOpcion("bpp", opcBpp);
						p->getConfiguracion()->guardarOpciones();
						p->cargarConfiguracion ();
						nivel = 0;
						SDL_SetClipRect (p->screen, &clip_completo);
						dibujar();
						SDL_Flip (p->screen);
						posInicialOpciones();
						posFinalOpciones_Opciones();
						switch (opcVelocidadJuego) {
							case 0:
								return 52;
							break;
							case 1:
								return 42;
							break;
							case 2:
								return 32;
							break;
						}
					} else if ( getOpcion_Opcion() == 7) {
						posInicialOpciones();
						posFinalOpciones_Opciones();
						nivel = 0;
					}
				}					
			}
			SDL_SetClipRect (p->screen, &clip_completo);
			dibujar();
			SDL_Flip (p->screen);
		}
	break;
	case 2:
		while (SDL_PollEvent(&event)) {
			// Pulsando una tecla
			if (event.type == SDL_KEYDOWN) {
				posInicialOpciones();
				posFinalControles();
				nivel = 0;
				SDL_SetClipRect (p->screen, &clip_completo);
				dibujar();
				SDL_Flip (p->screen);
			}
			if (event.type == SDL_JOYBUTTONDOWN) {
				botonJoystickPulsado = event.jbutton.button;
				tiempoTextoPantalla = 30;
			}
		}
	break;
	case 3:
		while (SDL_PollEvent(&event)) {
			// Pulsando una tecla
			if ( (event.type == SDL_KEYDOWN) || (event.type == SDL_JOYBUTTONDOWN) ) {
				posInicialOpciones();
				posFinalPuntuaciones();
				nivel = 0;
				SDL_SetClipRect (p->screen, &clip_completo);
				dibujar();
				SDL_Flip (p->screen);
			}
		}
	break;
	case 4:
	// Comprobando teclas para opciones
		while (SDL_PollEvent(&event)) {
			// Pulsando una tecla
			if ( (event.type == SDL_KEYDOWN) || (event.type == SDL_JOYBUTTONDOWN) ) {
				// Pulsar ESCAPE se sale
				if ( (event.key.keysym.sym == SDLK_ESCAPE) || ( ( event.jbutton.button == 0 ) && (event.type == SDL_JOYBUTTONDOWN) ) ) { 
					posFinalClave();
					posInicialOpciones();
					nivel = 0;
					strcpy(claveFase,"");
					tamClaveFase = 0;
				/*
				Si has llegado hasta este punto con la intención ver las claves de la 
				fase y te sientes orgulloso por haber destripado el código del juego
				sólo decirte que lo que has hecho no tiene ningún mérito. Podría
				haber encriptado las claves y ponértelo un poco más difícil pero
				no es mi misión hacer eso. Sólo te puedo decir lo que me dijo mi 
				profesor de latín de segundo de BUP: "Si copias, te estás engañando
				a ti mismo". Aro, aro, y yo con Notable en Latín en 2º que no 
				se lo cree nadie, jejeje. De todas formas, si has tardado más de 5
				minutos en llegar hasta aquí puedes estar seguro que no eres ningún
				hacker-cracker y si has tardado menos, es lo normal, así que tampoco
				lo eres. Hubieses tardo menos en enviarme un email y yo te hubiese
				mandado las claves sin problemas.
				
				Fdo: El programador
				*/
				} else	if ( (event.key.keysym.sym == SDLK_RETURN) && (event.type == SDL_KEYDOWN) ) { 
					if (strcmp(claveFase, "alikindoi")==0) {
						p->sonido->terminarMusica ();
						posFinalClave();
						posInicialOpciones();
						strcpy(claveFase,"");
						tamClaveFase = 0;
						nivel = 0;
						p->initSpriteNivel(2);
						Mix_HaltChannel(-1);
						//if ( p->getCiclos() > 0 ) {
							p->iniciarPantalla();
							p->iniciarJuego();
							p->getJuego()->establecerContinue();
							p->getJuego()->setZonaSobrepasada(0);
						//} else {
							p->empezarMusicaFase();
							//p->entradaJugador();
						//}
						return JUEGO_ESCENA;
					} else if (strcmp(claveFase, "wachisnai")==0) {
						p->sonido->terminarMusica ();
						posFinalClave();
						posInicialOpciones();
						strcpy(claveFase,"");
						tamClaveFase = 0;
						nivel = 0;
						p->initSpriteNivel(3);
						Mix_HaltChannel(-1);
						//if ( p->getCiclos() > 0 ) {
							p->iniciarPantalla();
							p->iniciarJuego();
							p->getJuego()->establecerContinue();
							p->getJuego()->setZonaSobrepasada(0);
						//} else {
							p->empezarMusicaFase();
							//p->entradaJugador();
						//}
						return JUEGO_ESCENA;
					} else if (strcmp(claveFase, "finaluno")==0) {
						p->sonido->terminarMusica ();
						posFinalClave();
						posInicialOpciones();
						strcpy(claveFase,"");
						tamClaveFase = 0;
						nivel = 0;
						p->initSpriteNivel(1);
						Mix_HaltChannel(-1);
						//if ( p->getCiclos() > 0 ) {
							p->iniciarPantalla();
							p->getJuego()->setCiclos(4700);
							p->iniciarJuego();
							p->getJuego()->establecerContinue();
							p->getJuego()->setZonaSobrepasada(0);
						//} else {
							p->empezarMusicaFase();
							p->entradaJugador();
						//}
						return JUEGO_ESCENA;
					} else if (strcmp(claveFase, "finaldos")==0) {
						p->sonido->terminarMusica ();
						posFinalClave();
						posInicialOpciones();
						strcpy(claveFase,"");
						tamClaveFase = 0;
						nivel = 0;
						p->initSpriteNivel(2);
						Mix_HaltChannel(-1);
						
						p->iniciarPantalla();
						p->getJuego()->setCiclos(4050);
						p->iniciarJuego();
						p->getJuego()->establecerContinue();
						p->getJuego()->setZonaSobrepasada(0);
						p->empezarMusicaFase();
						p->entradaJugador();
						return JUEGO_ESCENA;
					} else if (strcmp(claveFase, "finaltres")==0) {
						p->sonido->terminarMusica ();
						posFinalClave();
						posInicialOpciones();
						strcpy(claveFase,"");
						tamClaveFase = 0;
						nivel = 0;
						p->initSpriteNivel(3);
						Mix_HaltChannel(-1);
						//if ( p->getCiclos() > 0 ) {
							p->iniciarPantalla();
							p->getJuego()->setCiclos(4450);
							p->iniciarJuego();
							p->getJuego()->establecerContinue();
							p->getJuego()->setZonaSobrepasada(0);
						//} else {
							p->empezarMusicaFase();
							p->entradaJugador();
						//}
						return JUEGO_ESCENA;
					} else if (strcmp(claveFase, "nubes")==0) {
						p->sonido->terminarMusica ();
						posFinalClave();
						posInicialOpciones();
						strcpy(claveFase,"");
						tamClaveFase = 0;
						nivel = 0;
						p->initSpriteNivel(1);
						Mix_HaltChannel(-1);
						
						p->iniciarPantalla();
						p->getJuego()->setCiclos(8*260);	
						p->getMapa()->iniciar(8);
						
						p->iniciarJuego();
						p->getJuego()->establecerContinue();
						p->getJuego()->setZonaSobrepasada(0);
						p->empezarMusicaFase();
						p->entradaJugador();
						return JUEGO_ESCENA;
					} else if (strcmp(claveFase, "cano")==0) {
						p->sonido->terminarMusica ();
						posFinalClave();
						posInicialOpciones();
						strcpy(claveFase,"");
						tamClaveFase = 0;
						nivel = 0;
						p->initSpriteNivel(2);
						Mix_HaltChannel(-1);
						
						p->iniciarPantalla();
						p->getJuego()->setCiclos(7*260);	
						p->getMapa()->iniciar(7);
						
						p->iniciarJuego();
						p->getJuego()->establecerContinue();
						p->getJuego()->setZonaSobrepasada(0);
						p->empezarMusicaFase();
						p->entradaJugador();
						return JUEGO_ESCENA;
					} else if (strcmp(claveFase, "cabargata")==0) {
						p->sonido->terminarMusica ();
						posFinalClave();
						posInicialOpciones();
						strcpy(claveFase,"");
						tamClaveFase = 0;
						nivel = 0;
						p->initSpriteNivel(3);
						Mix_HaltChannel(-1);
						
						p->iniciarPantalla();
						p->getJuego()->setCiclos(8*260);	
						p->getMapa()->iniciar(8);
						
						p->iniciarJuego();
						p->getJuego()->establecerContinue();
						p->getJuego()->setZonaSobrepasada(0);
						p->empezarMusicaFase();
						p->entradaJugador();
						return JUEGO_ESCENA;
					} else if (strcmp(claveFase, "finaldeltodo")==0) {
						char cadena[127], archivo[27];
						anim = new SDL_Animation(p->screen, 640, 480);
						sprintf (cadena, "%s/verabd.tttf", DATA_DIR);
						anim->inVariable("fuente", cadena);
						anim->inVariable("conf_ruta", p->getConfiguracion()->getDirectorio());
						sprintf (cadena, "%s/diario_fase3.tvs", DATA_DIR);
						sprintf (archivo, "diario_fase3.tvs");
						anim->loadBuffer(p->BufferFromRar(cadena, "diario.txml"), archivo);
						verAnimacion = true;
						p->sonido->terminarMusica ();
					} else if (strcmp(claveFase, "conv")==0) {
						char cadena[127];
						char xml[127];
					
						anim = new SDL_Animation(p->screen, 640, 480);
						sprintf (cadena, "%s/verabd.tttf", DATA_DIR);
						anim->inVariable("fuente", cadena);
						anim->inVariable("conf_ruta", p->getConfiguracion()->getDirectorio());
					
						sprintf (cadena, "%s/conversaciones.tc", DATA_DIR);
						sprintf (xml, "fase2_2_2.txml"); 
						anim->loadBuffer(p->BufferFromRar(cadena, xml), "intercom.tim");
						verAnimacion = true;
						
						p->sonido->terminarMusica ();
					} else {
						errorClave = 40;
					}
				} else if ( (event.key.keysym.sym == SDLK_BACKSPACE) && (event.type == SDL_KEYDOWN) ) { 
					if (tamClaveFase>0) {
						tamClaveFase--;
						claveFase[tamClaveFase] = tmpClaveFase[0];
					}
				} else {
					if (event.type == SDL_KEYDOWN) {
						if (teclaValida(event.key.keysym.sym) ) {
							if (strlen(claveFase)<15) {
								sprintf(claveFase, "%s%s", claveFase, SDL_GetKeyName(event.key.keysym.sym));
								tamClaveFase++;
							}
						}
					}
				}
				SDL_SetClipRect (p->screen, &clip_completo);
				dibujar();
				SDL_Flip (p->screen);
			}
		}
	break;
	case 6:
		while (SDL_PollEvent(&event)) {
			// Pulsando una tecla
			if ( (event.type == SDL_KEYDOWN) || (event.type == SDL_JOYBUTTONDOWN) ) {
				posInicialOpciones();
				posFinalCreditos();
				nivel = 0;
				SDL_SetClipRect (p->screen, &clip_completo);
				dibujar();
				SDL_Flip (p->screen);
			}
		}
	break;
	}
	return 0;
}

void Opciones::dibujar() {
	
	int i;

	fondo->dibujar(p->screen);
	
	// nivel 0
	caja->mover();
	caja->dibujar(p->screen);
	
	if (!balancearModelo) {
		modelo->mover();
	} else {
		modelo->setTipoCoordenadas(COORDENADASNORMALES);
		if (modelo->getY()<80) {
			transModelo = -transModelo;
		}
		if (modelo->getY()>90) {
			transModelo = -transModelo;
		}
		modelo->addY(transModelo);
	}
	if ( (modelo->getY()<90) && (modelo->getY()>80) ) {
		balancearModelo = true;
	}
	modelo->dibujar(p->screen);

	for (i=0; i<NOPCIONES; i++) {
		ele_nOpciones[i]->mover();
		if ( i == opcion) {
			ele_nOpciones[i]->selFrame(1);
		} else {
			ele_nOpciones[i]->selFrame(0);
		}
		ele_nOpciones[i]->dibujar(p->screen);
	}
	
	// nivel 1 (opciones)
	opciones->mover();
	opciones->dibujar(p->screen);
	for (i=0; i<NOPCIONES_OPCIONES; i++) {
		ele_nOpciones_Opciones[i]->mover();
		if ( i == opcion_opciones) {
			ele_nOpciones_Opciones[i]->selFrame(1);
		} else {
			ele_nOpciones_Opciones[i]->selFrame(0);
		}
		ele_nOpciones_Opciones[i]->dibujar(p->screen);
	}
	
	for (i=0; i<4; i++) {
		if (opcion_opciones == 0) {
			ele_nOpcionesMusica[i]->selFrame(1);
		} else {
			ele_nOpcionesMusica[i]->selFrame(0);
		}
		ele_nOpcionesMusica[i]->mover();
		ele_nOpcionesMusica[opcMusica]->dibujar(p->screen);
	}
	
	for (i=0; i<4; i++) {
		if (opcion_opciones == 1) {
			ele_nOpcionesSonido[i]->selFrame(1);
		} else {
			ele_nOpcionesSonido[i]->selFrame(0);
		}
		ele_nOpcionesSonido[i]->mover();
		ele_nOpcionesSonido[opcSonido]->dibujar(p->screen);
	}
	
	for (i=0; i<2; i++) {
		if (opcion_opciones == 2) {
			ele_nOpcionesHardware[i]->selFrame(1);
		} else {
			ele_nOpcionesHardware[i]->selFrame(0);
		}
		ele_nOpcionesHardware[i]->mover();
		ele_nOpcionesHardware[opcHardware]->dibujar(p->screen);
	}
	
	for (i=0; i<3; i++) {
		if (opcion_opciones == 3) {
			ele_nOpcionesVelocidadJuego[i]->selFrame(1);
		} else {
			ele_nOpcionesVelocidadJuego[i]->selFrame(0);
		}
		ele_nOpcionesVelocidadJuego[i]->mover();
		ele_nOpcionesVelocidadJuego[opcVelocidadJuego]->dibujar(p->screen);
	}
	
	for (i=0; i<2; i++) {
		if (opcion_opciones == 4) {
			ele_nOpcionesFullScreen[i]->selFrame(1);
		} else {
			ele_nOpcionesFullScreen[i]->selFrame(0);
		}
		ele_nOpcionesFullScreen[i]->mover();
		ele_nOpcionesFullScreen[opcFullScreen]->dibujar(p->screen);
	}
	
	for (i=0; i<3; i++) {
		if (opcion_opciones == 5) {
			ele_nOpcionesBpp[i]->selFrame(1);
		} else {
			ele_nOpcionesBpp[i]->selFrame(0);
		}
		ele_nOpcionesBpp[i]->mover();
		ele_nOpcionesBpp[opcBpp]->dibujar(p->screen);
	}
	
	// nivel 2	(controles)
	teclado->mover();
	teclado->dibujar(p->screen);
	joystick->mover();
	joystick->dibujar(p->screen);
	int joyx, joyy;
	if (nivel==2) {	
		if (SDL_NumJoysticks()>0) {
			joy_conectado->dibujar(p->screen);
			//fuente->escribirTexto(p->screen, 0, ALIGN_CENTER, VALIGN_CENTER, 17, "Joystick conectado", 0, 0, 0, 0, 0, 30, 485, 215);
			//fuente->escribirTexto(p->screen, 0, ALIGN_CENTER, VALIGN_CENTER, 17, "Joystick conectado", 255, 230, 23, 0, 0, 0, 480, 210);
			SDL_JoystickUpdate();
			joyx = SDL_JoystickGetAxis (p->joystick->joystick, 0);
			joyy = SDL_JoystickGetAxis (p->joystick->joystick, 1);
			if ( (joyy < -3200) && (cruz->getY() > 256) ) {
				cruz->addY (-7);
			}
			
			if ( (joyy > 3200) && (cruz->getY() < 308 ) ) {
				cruz->addY (7);
			}
					
			if ( ( joyx < -3200) && (cruz->getX()  > 435) ) {
				cruz->addX (-7);
			}
					
			if ( (joyx > 3200) && (cruz->getX() < 499 ) ) {
				cruz->addX (7);
			}
			cruz->dibujar(p->screen);
		} else {
			joy_noconectado->dibujar(p->screen);
			//fuente->escribirTexto(p->screen, 0, ALIGN_CENTER, VALIGN_CENTER, 17, "Joystick no conectado", 0, 0, 0, 0, 0, 30, 485, 215);
			//fuente->escribirTexto(p->screen, 0, ALIGN_CENTER, VALIGN_CENTER, 17, "Joystick no conectado", 255, 230, 23, 0, 0, 0, 480, 210);
		}
		if ( botonJoystickPulsado == JOY_DISPARO ) {
			joy_disparo->dibujar(p->screen);
			//fuente->escribirTexto(p->screen, 0, ALIGN_CENTER, VALIGN_CENTER, 18, "DISPARO", 0, 0, 0, 0, 0, 30, 475, 405);
			//fuente->escribirTexto(p->screen, 0, ALIGN_CENTER, VALIGN_CENTER, 18, "DISPARO", 255, 230, 23, 0, 0, 0, 470, 400);
			tiempoTextoPantalla--;
			if (tiempoTextoPantalla == 0) {
				botonJoystickPulsado = -1;
			}
		} else if ( botonJoystickPulsado == JOY_SEL_PODER ) {
			joy_sel_poder->dibujar(p->screen);
			//fuente->escribirTexto(p->screen, 0, ALIGN_CENTER, VALIGN_CENTER, 18, "SELECCIONAR PODER", 0, 0, 0, 0, 0, 30, 475, 405);
			//fuente->escribirTexto(p->screen, 0, ALIGN_CENTER, VALIGN_CENTER, 18, "SELECCIONAR PODER", 255, 230, 23, 0, 0, 0, 470, 400);
			tiempoTextoPantalla--;
			if (tiempoTextoPantalla == 0) {
				botonJoystickPulsado = -1;
			}
		} else if ( botonJoystickPulsado == JOY_USAR_PODER ) {
			joy_usar_poder->dibujar(p->screen);
			//fuente->escribirTexto(p->screen, 0, ALIGN_CENTER, VALIGN_CENTER, 18, "USAR PODER", 0, 0, 0, 0, 0, 30, 475, 405);
			//fuente->escribirTexto(p->screen, 0, ALIGN_CENTER, VALIGN_CENTER, 18, "USAR PODER", 255, 230, 23, 0, 0, 0, 470, 400);
			tiempoTextoPantalla--;
			if (tiempoTextoPantalla == 0) {
				botonJoystickPulsado = -1;
			}
		} else if ( botonJoystickPulsado == JOY_INTERCOM ) {
			joy_intercom->dibujar(p->screen);
			//fuente->escribirTexto(p->screen, 0, ALIGN_CENTER, VALIGN_CENTER, 18, "INTERCOM", 0, 0, 0, 0, 0, 30, 475, 405);
			//fuente->escribirTexto(p->screen, 0, ALIGN_CENTER, VALIGN_CENTER, 18, "INTERCOM", 255, 230, 23, 0, 0, 0, 470, 400);
			tiempoTextoPantalla--;
			if (tiempoTextoPantalla == 0) {
				botonJoystickPulsado = -1;
			}
		}
	}
	
	// nivel 3 (puntuaciones)
	puntuaciones->mover();
	puntuaciones->dibujar(p->screen);
	
	for (i=0; i<5; i++) {
		ele_PuntNombres[i]->mover();
		ele_PuntNombres[i]->dibujar(p->screen);
		ele_PuntPuntos[i]->mover();
		ele_PuntPuntos[i]->dibujar(p->screen);
	}
	
	
	// nivel 4 (clave)
	
	clave->mover();
	clave->dibujar(p->screen);

	if (nivel==4) {	
		fuente->escribirTexto(p->screen, 0, ALIGN_CENTER, VALIGN_CENTER, sizeFontSel, claveFase, 0, 0, 0, 0, 0, 30, (p->pantalla_w/2)+5, 305);
		fuente->escribirTexto(p->screen, 0, ALIGN_CENTER, VALIGN_CENTER, sizeFontSel, claveFase, 255, 230, 23, 0, 0, 0, (p->pantalla_w/2), 300);
		if (errorClave>0) {
			fuente->escribirTexto(p->screen, 0, ALIGN_CENTER, VALIGN_CENTER, 14, "Esta clave no pertenece a ninguna mision", 255, 230, 23, 0, 0, 0, (p->pantalla_w/2), 360);
			errorClave--;
		}
	}
	
	// nivel 6 (creditos)
	creditos->mover();
	creditos->dibujar(p->screen);


}


bool Opciones::teclaValida(SDLKey letra) {
	
	if (letra >= SDLK_a && letra <= SDLK_z)
		return 1;
	else
		return 0;
}
